/* Generated by re2c 1.1.1 on Wed Jul 14 00:47:45 2021 */
#line 1 "tokenizer.re"
#include <limits>

#include "tokenizer.h"
#include <lfortran/bigint.h>
#include "parser.tab.hh"

namespace LFortran
{

void lex_format(unsigned char *&cur, Location &loc,
        unsigned char *&start);

void Tokenizer::set_string(const std::string &str)
{
    // The input string must be NULL terminated, otherwise the tokenizer will
    // not detect the end of string. After C++11, the std::string is guaranteed
    // to end with \0, but we check this here just in case.
    LFORTRAN_ASSERT(str[str.size()] == '\0');
    cur = (unsigned char *)(&str[0]);
    cur_line = cur;
    line_num = 1;
}

template<int base>
bool adddgt(uint64_t &u, uint64_t d)
{
    if (u > (std::numeric_limits<uint64_t>::max() - d) / base) {
        return false;
    }
    u = u * base + d;
    return true;
}

bool lex_dec(const unsigned char *s, const unsigned char *e, uint64_t &u)
{
    for (u = 0; s < e; ++s) {
        if (!adddgt<10>(u, *s - 0x30u)) {
            return false;
        }
    }
    return true;
}

// Tokenizes integer of the kind 1234_ikind into `u` and `suffix`
// s ... the start of the integer
// e ... the character after the end
bool lex_int(const unsigned char *s, const unsigned char *e, uint64_t &u,
    Str &suffix)
{
    for (u = 0; s < e; ++s) {
        if (*s == '_') {
            s++;
            suffix.p = (char*) s;
            suffix.n = e-s;
            return true;
        } else if (!adddgt<10>(u, *s - 0x30u)) {
            return false;
        }
    }
    suffix.p = nullptr;
    suffix.n = 0;
    return true;
}

void lex_int_large(Allocator &al, const unsigned char *s,
    const unsigned char *e, BigInt::BigInt &u, Str &suffix)
{
    uint64_t ui;
    if (lex_int(s, e, ui, suffix)) {
        if (ui <= BigInt::MAX_SMALL_INT) {
            u.from_smallint(ui);
            return;
        }
    }
    const unsigned char *start = s;
    for (; s < e; ++s) {
        if (*s == '_') {
            s++;
            suffix.p = (char*) s;
            suffix.n = e-s;

            Str num;
            num.p = (char*)start;
            num.n = s-start-1;
            u.from_largeint(al, num);
            return;
        }
    }
    suffix.p = nullptr;
    suffix.n = 0;
    Str num;
    num.p = (char*)start;
    num.n = e-start;
    u.from_largeint(al, num);
}

#define KW(x) token(yylval.string); RET(KW_##x);
#define RET(x) token_loc(loc); last_token=yytokentype::x; return yytokentype::x;

int Tokenizer::lex(Allocator &al, YYSTYPE &yylval, Location &loc)
{
    for (;;) {
        tok = cur;

        /*
        Re2c has an excellent documentation at:

        https://re2c.org/manual/manual_c.html

        The first paragraph there explains the basics:

        * If multiple rules match, the longest match takes precedence
        * If multiple rules match the same string, the earlier rule takes
          precedence
        * Default rule `*` should always be defined, it has the lowest priority
          regardless of its place and matches any code unit

        The code below executes on its own until a rule is matched: the action
        in {} is then executed. In that action we can use `tok` and `cur` to
        extract the token:

        * `tok` points to the first character of the token
        * `cur-1` points to the last character of the token
        * `cur` points to the first character of the next token

        In the action, we do one of:

        * call `continue` which executes another cycle in the for loop (which
          will parse the next token); we use this to skip a token
        * call `return` which returns from this function; we return a token
        * throw an exception (terminates the tokenizer)

        In the first two cases, `cur` points to first character of the next
        token, which becomes `tok` at the next iteration of the loop (either
        right away after `continue` or after the `lex` function is called again
        after `return`).

        When the re2c block starts, `cur` must point to the next token that
        should be tokenized. We remember its value in `tok`. When the action {}
        enters, `cur` points to the following token and `cur-tok` is the length
        of the new token that got tokenized.

        See the manual for more details.
        */


        // These two variables are needed by the re2c block below internally,
        // initialization is not needed.
        unsigned char *mar, *ctxmar;
        
#line 154 "tokenizer.cpp"
{
	unsigned char yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		/* table 1 .. 8: 0 */
		  0,   2,   2,   2,   2,   2,   2,   2, 
		  2,   3,   3,   3,   2,   3,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  3,   2,   2,   2,   2,   2,   2,   0, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		242, 242, 210, 210, 210, 210, 210, 210, 
		146, 146,   2,   2,   2,   2,   2,   2, 
		  2, 150, 150, 150, 150, 150, 150,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,   2,   2,   2,   2,  26, 
		  2, 150, 150, 150, 150, 150, 150,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		/* table 9 .. 13: 256 */
		  0, 192, 192, 192, 192, 192, 192, 192, 
		192, 200, 128, 200, 192, 200, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		200, 192,  64, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		240, 240, 240, 240, 240, 240, 240, 240, 
		240, 240, 192, 192, 192, 192, 192, 192, 
		192, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 192, 192, 192, 192, 192, 
		192, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
	};
	yych = *cur;
	if (yybm[256+yych] & 8) {
		goto yy6;
	}
	switch (yych) {
	case 0x00:	goto yy2;
	case '\t':
	case '\n':	goto yy9;
	case ' ':
	case '!':	goto yy11;
	case '"':	goto yy12;
	case '#':	goto yy13;
	case '%':	goto yy14;
	case '&':	goto yy16;
	case '\'':	goto yy17;
	case '(':	goto yy18;
	case ')':	goto yy20;
	case '*':	goto yy22;
	case '+':	goto yy24;
	case ',':	goto yy26;
	case '-':	goto yy28;
	case '.':	goto yy30;
	case '/':	goto yy31;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy33;
	case ':':	goto yy36;
	case ';':	goto yy38;
	case '<':	goto yy40;
	case '=':	goto yy42;
	case '>':	goto yy44;
	case 'A':
	case 'a':	goto yy46;
	case 'B':
	case 'b':	goto yy48;
	case 'C':
	case 'c':	goto yy49;
	case 'D':
	case 'd':	goto yy50;
	case 'E':
	case 'e':	goto yy51;
	case 'F':
	case 'f':	goto yy52;
	case 'G':
	case 'g':	goto yy53;
	case 'H':
	case 'J':
	case 'X':
	case 'Y':
	case '_':
	case 'h':
	case 'j':
	case 'x':
	case 'y':	goto yy54;
	case 'I':
	case 'i':	goto yy56;
	case 'K':
	case 'k':	goto yy57;
	case 'L':
	case 'l':	goto yy58;
	case 'M':
	case 'm':	goto yy59;
	case 'N':
	case 'n':	goto yy60;
	case 'O':
	case 'o':	goto yy61;
	case 'P':
	case 'p':	goto yy62;
	case 'Q':
	case 'q':	goto yy63;
	case 'R':
	case 'r':	goto yy64;
	case 'S':
	case 's':	goto yy65;
	case 'T':
	case 't':	goto yy66;
	case 'U':
	case 'u':	goto yy67;
	case 'V':
	case 'v':	goto yy68;
	case 'W':
	case 'w':	goto yy69;
	case 'Z':
	case 'z':	goto yy70;
	case '[':	goto yy71;
	case ']':	goto yy73;
	case '|':	goto yy75;
	default:	goto yy4;
	}
yy2:
	++cur;
#line 179 "tokenizer.re"
	{ RET(END_OF_FILE); }
#line 326 "tokenizer.cpp"
yy4:
	++cur;
yy5:
#line 174 "tokenizer.re"
	{ token_loc(loc);
                std::string t = token();
                throw LFortran::TokenizerError("token '" + t
                    + "' is not recognized", loc, t);
            }
#line 336 "tokenizer.cpp"
yy6:
	yych = *++cur;
	if (yybm[256+yych] & 8) {
		goto yy6;
	}
#line 180 "tokenizer.re"
	{ continue; }
#line 344 "tokenizer.cpp"
yy9:
	++cur;
#line 394 "tokenizer.re"
	{
                    token_loc(loc); line_num++; cur_line=cur;
                    last_token = yytokentype::TK_NEWLINE;
                    return yytokentype::TK_NEWLINE;
            }
#line 353 "tokenizer.cpp"
yy11:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy78;
yy12:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy83;
yy13:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy87;
yy14:
	++cur;
#line 414 "tokenizer.re"
	{ RET(TK_PERCENT) }
#line 373 "tokenizer.cpp"
yy16:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= 0x08) goto yy5;
		if (yych <= '\v') goto yy91;
		goto yy5;
	} else {
		if (yych <= '\r') goto yy91;
		if (yych <= 0x1F) goto yy5;
		if (yych <= '!') goto yy91;
		goto yy5;
	}
yy17:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy98;
yy18:
	yych = *++cur;
	if (yych == '/') goto yy101;
#line 401 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 397 "tokenizer.cpp"
yy20:
	++cur;
#line 404 "tokenizer.re"
	{ RET(TK_RPAREN) }
#line 402 "tokenizer.cpp"
yy22:
	yych = *++cur;
	if (yych == '*') goto yy102;
#line 416 "tokenizer.re"
	{ RET(TK_STAR) }
#line 408 "tokenizer.cpp"
yy24:
	++cur;
#line 408 "tokenizer.re"
	{ RET(TK_PLUS) }
#line 413 "tokenizer.cpp"
yy26:
	++cur;
#line 415 "tokenizer.re"
	{ RET(TK_COMMA) }
#line 418 "tokenizer.cpp"
yy28:
	++cur;
#line 409 "tokenizer.re"
	{ RET(TK_MINUS) }
#line 423 "tokenizer.cpp"
yy30:
	yyaccept = 0;
	yych = *(mar = ++cur);
	switch (yych) {
	case '.':	goto yy104;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy106;
	case 'A':
	case 'a':	goto yy109;
	case 'B':
	case 'C':
	case 'D':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'M':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case 'b':
	case 'c':
	case 'd':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'm':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy110;
	case 'E':
	case 'e':	goto yy112;
	case 'F':
	case 'f':	goto yy113;
	case 'G':
	case 'g':	goto yy114;
	case 'L':
	case 'l':	goto yy115;
	case 'N':
	case 'n':	goto yy116;
	case 'O':
	case 'o':	goto yy117;
	case 'T':
	case 't':	goto yy118;
	default:	goto yy5;
	}
yy31:
	yych = *++cur;
	if (yych <= '.') {
		if (yych == ')') goto yy119;
	} else {
		if (yych <= '/') goto yy121;
		if (yych == '=') goto yy123;
	}
#line 413 "tokenizer.re"
	{ RET(TK_SLASH) }
#line 503 "tokenizer.cpp"
yy33:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 16) {
		goto yy33;
	}
	if (yych <= ' ') {
		if (yych <= '\v') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych >= '\v') {
				ctxmar = cur;
				goto yy125;
			}
		} else {
			if (yych == '\r') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych >= ' ') {
				ctxmar = cur;
				goto yy125;
			}
		}
	} else {
		if (yych <= 'E') {
			if (yych == '.') {
				ctxmar = cur;
				goto yy127;
			}
			if (yych >= 'D') goto yy128;
		} else {
			if (yych <= '_') {
				if (yych >= '_') goto yy129;
			} else {
				if (yych <= 'c') goto yy35;
				if (yych <= 'e') goto yy128;
			}
		}
	}
yy35:
#line 479 "tokenizer.re"
	{
                lex_int_large(al, tok, cur,
                    yylval.int_suffix.int_n,
                    yylval.int_suffix.int_kind);
                RET(TK_INTEGER)
            }
#line 554 "tokenizer.cpp"
yy36:
	yych = *++cur;
	if (yych == ':') goto yy130;
#line 411 "tokenizer.re"
	{ RET(TK_COLON) }
#line 560 "tokenizer.cpp"
yy38:
	++cur;
#line 412 "tokenizer.re"
	{ RET(TK_SEMICOLON) }
#line 565 "tokenizer.cpp"
yy40:
	yych = *++cur;
	if (yych == '=') goto yy132;
yy41:
#line 429 "tokenizer.re"
	{ RET(TK_LT) }
#line 572 "tokenizer.cpp"
yy42:
	yych = *++cur;
	if (yych <= '<') goto yy43;
	if (yych <= '=') goto yy134;
	if (yych <= '>') goto yy136;
yy43:
#line 410 "tokenizer.re"
	{ RET(TK_EQUAL) }
#line 581 "tokenizer.cpp"
yy44:
	yych = *++cur;
	if (yych == '=') goto yy138;
yy45:
#line 431 "tokenizer.re"
	{ RET(TK_GT) }
#line 588 "tokenizer.cpp"
yy46:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych == 'B') goto yy140;
			goto yy55;
		} else {
			if (yych <= 'L') goto yy141;
			if (yych <= 'R') goto yy55;
			goto yy142;
		}
	} else {
		if (yych <= 'k') {
			if (yych == 'b') goto yy140;
			goto yy55;
		} else {
			if (yych <= 'l') goto yy141;
			if (yych == 's') goto yy142;
			goto yy55;
		}
	}
yy47:
#line 510 "tokenizer.re"
	{ token(yylval.string); RET(TK_NAME) }
#line 613 "tokenizer.cpp"
yy48:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'I') {
		if (yych <= '\'') {
			if (yych == '"') goto yy145;
			if (yych <= '&') goto yy55;
			goto yy146;
		} else {
			if (yych == 'A') goto yy147;
			if (yych <= 'H') goto yy55;
			goto yy148;
		}
	} else {
		if (yych <= 'a') {
			if (yych == 'L') goto yy149;
			if (yych <= '`') goto yy55;
			goto yy147;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy55;
				goto yy148;
			} else {
				if (yych == 'l') goto yy149;
				goto yy55;
			}
		}
	}
yy49:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy150;
	case 'H':
	case 'h':	goto yy151;
	case 'L':
	case 'l':	goto yy152;
	case 'O':
	case 'o':	goto yy153;
	case 'R':
	case 'r':	goto yy154;
	case 'Y':
	case 'y':	goto yy155;
	default:	goto yy55;
	}
yy50:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych <= 'E') {
			if (yych == 'A') goto yy156;
			if (yych <= 'D') goto yy55;
			goto yy157;
		} else {
			if (yych == 'I') goto yy158;
			if (yych <= 'N') goto yy55;
			goto yy159;
		}
	} else {
		if (yych <= 'e') {
			if (yych == 'a') goto yy156;
			if (yych <= 'd') goto yy55;
			goto yy157;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy55;
				goto yy158;
			} else {
				if (yych == 'o') goto yy159;
				goto yy55;
			}
		}
	}
yy51:
	yych = *++cur;
	switch (yych) {
	case 'L':
	case 'l':	goto yy161;
	case 'N':
	case 'n':	goto yy162;
	case 'Q':
	case 'q':	goto yy163;
	case 'R':
	case 'r':	goto yy164;
	case 'V':
	case 'v':	goto yy165;
	case 'X':
	case 'x':	goto yy166;
	default:	goto yy55;
	}
yy52:
	yych = *++cur;
	switch (yych) {
	case 'I':
	case 'i':	goto yy167;
	case 'L':
	case 'l':	goto yy168;
	case 'O':
	case 'o':	goto yy169;
	case 'U':
	case 'u':	goto yy170;
	default:	goto yy55;
	}
yy53:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy171;
		if (yych <= 'N') goto yy55;
		goto yy172;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy171;
		} else {
			if (yych == 'o') goto yy172;
			goto yy55;
		}
	}
yy54:
	yych = *++cur;
yy55:
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
	goto yy47;
yy56:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'L') {
			if (yych == 'F') goto yy174;
			goto yy55;
		} else {
			if (yych <= 'M') goto yy176;
			if (yych <= 'N') goto yy177;
			if (yych <= 'R') goto yy55;
			goto yy179;
		}
	} else {
		if (yych <= 'm') {
			if (yych == 'f') goto yy174;
			if (yych <= 'l') goto yy55;
			goto yy176;
		} else {
			if (yych <= 'n') goto yy177;
			if (yych == 's') goto yy179;
			goto yy55;
		}
	}
yy57:
	yych = *++cur;
	if (yych == 'I') goto yy181;
	if (yych == 'i') goto yy181;
	goto yy55;
yy58:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy182;
		if (yych <= 'N') goto yy55;
		goto yy183;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy182;
		} else {
			if (yych == 'o') goto yy183;
			goto yy55;
		}
	}
yy59:
	yych = *++cur;
	if (yych == 'O') goto yy184;
	if (yych == 'o') goto yy184;
	goto yy55;
yy60:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'A') goto yy185;
			goto yy55;
		} else {
			if (yych <= 'O') goto yy186;
			if (yych <= 'T') goto yy55;
			goto yy187;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'a') goto yy185;
			goto yy55;
		} else {
			if (yych <= 'o') goto yy186;
			if (yych == 'u') goto yy187;
			goto yy55;
		}
	}
yy61:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'P') {
		if (yych <= '\'') {
			if (yych == '"') goto yy188;
			if (yych <= '&') goto yy55;
			goto yy189;
		} else {
			if (yych == 'N') goto yy190;
			if (yych <= 'O') goto yy55;
			goto yy191;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'U') goto yy192;
			if (yych <= 'm') goto yy55;
			goto yy190;
		} else {
			if (yych <= 'p') {
				if (yych <= 'o') goto yy55;
				goto yy191;
			} else {
				if (yych == 'u') goto yy192;
				goto yy55;
			}
		}
	}
yy62:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'O') {
			if (yych == 'A') goto yy193;
			if (yych <= 'N') goto yy55;
			goto yy194;
		} else {
			if (yych == 'R') goto yy195;
			if (yych <= 'T') goto yy55;
			goto yy196;
		}
	} else {
		if (yych <= 'o') {
			if (yych == 'a') goto yy193;
			if (yych <= 'n') goto yy55;
			goto yy194;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy55;
				goto yy195;
			} else {
				if (yych == 'u') goto yy196;
				goto yy55;
			}
		}
	}
yy63:
	yych = *++cur;
	if (yych == 'U') goto yy197;
	if (yych == 'u') goto yy197;
	goto yy55;
yy64:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy198;
		if (yych <= 'D') goto yy55;
		goto yy199;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy198;
		} else {
			if (yych == 'e') goto yy199;
			goto yy55;
		}
	}
yy65:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy200;
	case 'E':
	case 'e':	goto yy201;
	case 'H':
	case 'h':	goto yy202;
	case 'O':
	case 'o':	goto yy203;
	case 'T':
	case 't':	goto yy204;
	case 'U':
	case 'u':	goto yy205;
	case 'Y':
	case 'y':	goto yy206;
	default:	goto yy55;
	}
yy66:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy207;
	case 'E':
	case 'e':	goto yy208;
	case 'H':
	case 'h':	goto yy209;
	case 'O':
	case 'o':	goto yy210;
	case 'Y':
	case 'y':	goto yy212;
	default:	goto yy55;
	}
yy67:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'N') goto yy213;
		if (yych <= 'R') goto yy55;
		goto yy214;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy213;
		} else {
			if (yych == 's') goto yy214;
			goto yy55;
		}
	}
yy68:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy215;
		if (yych <= 'N') goto yy55;
		goto yy216;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy215;
		} else {
			if (yych == 'o') goto yy216;
			goto yy55;
		}
	}
yy69:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych <= 'G') {
			if (yych == 'A') goto yy217;
			goto yy55;
		} else {
			if (yych <= 'H') goto yy218;
			if (yych <= 'Q') goto yy55;
			goto yy219;
		}
	} else {
		if (yych <= 'g') {
			if (yych == 'a') goto yy217;
			goto yy55;
		} else {
			if (yych <= 'h') goto yy218;
			if (yych == 'r') goto yy219;
			goto yy55;
		}
	}
yy70:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy220;
	if (yych == '\'') goto yy221;
	goto yy55;
yy71:
	++cur;
yy72:
#line 405 "tokenizer.re"
	{ RET(TK_LBRACKET) }
#line 979 "tokenizer.cpp"
yy73:
	++cur;
#line 406 "tokenizer.re"
	{ RET(TK_RBRACKET) }
#line 984 "tokenizer.cpp"
yy75:
	++cur;
#line 417 "tokenizer.re"
	{ RET(TK_VBAR) }
#line 989 "tokenizer.cpp"
yy77:
	yych = *++cur;
yy78:
	if (yybm[256+yych] & 64) {
		goto yy77;
	}
	if (yych >= 0x01) goto yy80;
yy79:
	cur = mar;
	if (yyaccept <= 8) {
		if (yyaccept <= 4) {
			if (yyaccept <= 2) {
				if (yyaccept <= 1) {
					if (yyaccept == 0) {
						goto yy5;
					} else {
						goto yy35;
					}
				} else {
					goto yy47;
				}
			} else {
				if (yyaccept == 3) {
					goto yy85;
				} else {
					goto yy94;
				}
			}
		} else {
			if (yyaccept <= 6) {
				if (yyaccept == 5) {
					goto yy100;
				} else {
					goto yy72;
				}
			} else {
				if (yyaccept == 7) {
					goto yy108;
				} else {
					goto yy178;
				}
			}
		}
	} else {
		if (yyaccept <= 12) {
			if (yyaccept <= 10) {
				if (yyaccept == 9) {
					goto yy284;
				} else {
					goto yy704;
				}
			} else {
				if (yyaccept == 11) {
					goto yy834;
				} else {
					goto yy902;
				}
			}
		} else {
			if (yyaccept <= 14) {
				if (yyaccept == 13) {
					goto yy990;
				} else {
					goto yy1068;
				}
			} else {
				if (yyaccept == 15) {
					goto yy1180;
				} else {
					goto yy1182;
				}
			}
		}
	}
yy80:
	++cur;
	cur -= 1;
#line 497 "tokenizer.re"
	{ token(yylval.string); RET(TK_COMMENT) }
#line 1069 "tokenizer.cpp"
yy82:
	yych = *++cur;
yy83:
	if (yybm[256+yych] & 128) {
		goto yy82;
	}
	if (yych <= 0x00) goto yy79;
	yyaccept = 3;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy82;
yy85:
#line 506 "tokenizer.re"
	{ token_str(yylval.string); RET(TK_STRING) }
#line 1083 "tokenizer.cpp"
yy86:
	yych = *++cur;
yy87:
	if (yych <= 0x00) goto yy79;
	if (yych != '\n') goto yy86;
	++cur;
#line 500 "tokenizer.re"
	{ line_num++; cur_line=cur; continue; }
#line 1092 "tokenizer.cpp"
yy90:
	yych = *++cur;
yy91:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy90;
		} else {
			if (yych <= '\n') goto yy92;
			if (yych <= '\v') goto yy90;
			goto yy79;
		}
	} else {
		if (yych <= 0x1F) {
			if (yych <= '\r') goto yy90;
			goto yy79;
		} else {
			if (yych <= ' ') goto yy90;
			if (yych <= '!') goto yy95;
			goto yy79;
		}
	}
yy92:
	yyaccept = 4;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 1) {
		goto yy92;
	}
	if (yych <= 0x1F) goto yy94;
	if (yych <= '!') goto yy95;
	if (yych == '&') goto yy222;
yy94:
#line 493 "tokenizer.re"
	{
                line_num++; cur_line=cur; continue;
            }
#line 1129 "tokenizer.cpp"
yy95:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '\n') goto yy92;
	goto yy95;
yy97:
	yych = *++cur;
yy98:
	if (yybm[0+yych] & 2) {
		goto yy97;
	}
	if (yych <= 0x00) goto yy79;
	yyaccept = 5;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy97;
yy100:
#line 507 "tokenizer.re"
	{ token_str(yylval.string); RET(TK_STRING) }
#line 1148 "tokenizer.cpp"
yy101:
	yyaccept = 6;
	yych = *(mar = ++cur);
	if (yych == '/') goto yy223;
	if (yych == '=') goto yy224;
	goto yy72;
yy102:
	++cur;
#line 422 "tokenizer.re"
	{ RET(TK_POW) }
#line 1159 "tokenizer.cpp"
yy104:
	++cur;
#line 420 "tokenizer.re"
	{ RET(TK_DBL_DOT) }
#line 1164 "tokenizer.cpp"
yy106:
	yyaccept = 7;
	yych = *(mar = ++cur);
yy107:
	if (yych <= 'E') {
		if (yych <= '/') goto yy108;
		if (yych <= '9') goto yy106;
		if (yych >= 'D') goto yy128;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy226;
		} else {
			if (yych <= 'c') goto yy108;
			if (yych <= 'e') goto yy128;
		}
	}
yy108:
#line 459 "tokenizer.re"
	{ token(yylval.string); RET(TK_REAL) }
#line 1184 "tokenizer.cpp"
yy109:
	yych = *++cur;
	if (yych == 'N') goto yy229;
	if (yych == 'n') goto yy229;
	goto yy111;
yy110:
	yych = *++cur;
yy111:
	if (yybm[0+yych] & 4) {
		goto yy110;
	}
	if (yych == '.') goto yy227;
	goto yy79;
yy112:
	yych = *++cur;
	if (yych == 'Q') goto yy230;
	if (yych == 'q') goto yy230;
	goto yy111;
yy113:
	yych = *++cur;
	if (yych == 'A') goto yy231;
	if (yych == 'a') goto yy231;
	goto yy111;
yy114:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy232;
		if (yych <= 'S') goto yy111;
		goto yy233;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy232;
		} else {
			if (yych == 't') goto yy233;
			goto yy111;
		}
	}
yy115:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy234;
		if (yych <= 'S') goto yy111;
		goto yy235;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy234;
		} else {
			if (yych == 't') goto yy235;
			goto yy111;
		}
	}
yy116:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy236;
		if (yych <= 'N') goto yy111;
		goto yy237;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy236;
		} else {
			if (yych == 'o') goto yy237;
			goto yy111;
		}
	}
yy117:
	yych = *++cur;
	if (yych == 'R') goto yy238;
	if (yych == 'r') goto yy238;
	goto yy111;
yy118:
	yych = *++cur;
	if (yych == 'R') goto yy239;
	if (yych == 'r') goto yy239;
	goto yy111;
yy119:
	++cur;
#line 407 "tokenizer.re"
	{ RET(TK_RBRACKET_OLD) }
#line 1267 "tokenizer.cpp"
yy121:
	++cur;
#line 423 "tokenizer.re"
	{ RET(TK_CONCAT) }
#line 1272 "tokenizer.cpp"
yy123:
	++cur;
#line 428 "tokenizer.re"
	{ RET(TK_NE) }
#line 1277 "tokenizer.cpp"
yy125:
	yych = *++cur;
	if (yych <= 0x1F) {
		if (yych <= '\n') {
			if (yych == '\t') goto yy125;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			if (yych <= '\r') goto yy125;
			goto yy79;
		}
	} else {
		if (yych <= '^') {
			if (yych <= ' ') goto yy125;
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy240;
			goto yy79;
		} else {
			if (yych == '`') goto yy79;
			if (yych <= 'z') goto yy240;
			goto yy79;
		}
	}
yy127:
	yyaccept = 7;
	yych = *(mar = ++cur);
	if (yych <= 'Z') {
		if (yych <= '@') goto yy107;
		if (yych <= 'C') goto yy243;
		if (yych <= 'E') goto yy245;
		goto yy243;
	} else {
		if (yych <= 'c') {
			if (yych <= '`') goto yy107;
			goto yy243;
		} else {
			if (yych <= 'e') goto yy245;
			if (yych <= 'z') goto yy243;
			goto yy107;
		}
	}
yy128:
	yych = *++cur;
	if (yych <= ',') {
		if (yych == '+') goto yy246;
		goto yy79;
	} else {
		if (yych <= '-') goto yy246;
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy247;
		goto yy79;
	}
yy129:
	yych = *++cur;
	if (yych <= '9') {
		if (yych <= '&') {
			if (yych == '"') goto yy82;
			goto yy79;
		} else {
			if (yych <= '\'') goto yy97;
			if (yych <= '/') goto yy79;
			goto yy249;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy251;
			goto yy79;
		} else {
			if (yych == '`') goto yy79;
			if (yych <= 'z') goto yy251;
			goto yy79;
		}
	}
yy130:
	++cur;
#line 421 "tokenizer.re"
	{ RET(TK_DBL_COLON) }
#line 1356 "tokenizer.cpp"
yy132:
	++cur;
#line 430 "tokenizer.re"
	{ RET(TK_LE) }
#line 1361 "tokenizer.cpp"
yy134:
	++cur;
#line 427 "tokenizer.re"
	{ RET(TK_EQ) }
#line 1366 "tokenizer.cpp"
yy136:
	++cur;
#line 424 "tokenizer.re"
	{ RET(TK_ARROW) }
#line 1371 "tokenizer.cpp"
yy138:
	++cur;
#line 432 "tokenizer.re"
	{ RET(TK_GE) }
#line 1376 "tokenizer.cpp"
yy140:
	yych = *++cur;
	if (yych == 'S') goto yy253;
	if (yych == 's') goto yy253;
	goto yy55;
yy141:
	yych = *++cur;
	if (yych == 'L') goto yy254;
	if (yych == 'l') goto yy254;
	goto yy55;
yy142:
	yych = *++cur;
	if (yych <= 'Y') {
		if (yych == 'S') goto yy256;
		if (yych <= 'X') goto yy55;
		goto yy257;
	} else {
		if (yych <= 's') {
			if (yych <= 'r') goto yy55;
			goto yy256;
		} else {
			if (yych == 'y') goto yy257;
			goto yy55;
		}
	}
yy143:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych <= '&') {
		if (yych == '"') goto yy82;
		goto yy47;
	} else {
		if (yych <= '\'') goto yy97;
		if (yych == '_') goto yy143;
		goto yy47;
	}
yy145:
	yych = *++cur;
	if (yybm[0+yych] & 32) {
		goto yy258;
	}
	goto yy79;
yy146:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '1') goto yy260;
	goto yy79;
yy147:
	yych = *++cur;
	if (yych == 'C') goto yy262;
	if (yych == 'c') goto yy262;
	goto yy55;
yy148:
	yych = *++cur;
	if (yych == 'N') goto yy263;
	if (yych == 'n') goto yy263;
	goto yy55;
yy149:
	yych = *++cur;
	if (yych == 'O') goto yy264;
	if (yych == 'o') goto yy264;
	goto yy55;
yy150:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'L') goto yy265;
		if (yych <= 'R') goto yy55;
		goto yy266;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy265;
		} else {
			if (yych == 's') goto yy266;
			goto yy55;
		}
	}
yy151:
	yych = *++cur;
	if (yych == 'A') goto yy267;
	if (yych == 'a') goto yy267;
	goto yy55;
yy152:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy268;
		if (yych <= 'N') goto yy55;
		goto yy269;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy268;
		} else {
			if (yych == 'o') goto yy269;
			goto yy55;
		}
	}
yy153:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych <= 'D') {
			if (yych <= 'C') goto yy55;
			goto yy270;
		} else {
			if (yych <= 'L') goto yy55;
			if (yych <= 'M') goto yy271;
			goto yy272;
		}
	} else {
		if (yych <= 'l') {
			if (yych == 'd') goto yy270;
			goto yy55;
		} else {
			if (yych <= 'm') goto yy271;
			if (yych <= 'n') goto yy272;
			goto yy55;
		}
	}
yy154:
	yych = *++cur;
	if (yych == 'I') goto yy273;
	if (yych == 'i') goto yy273;
	goto yy55;
yy155:
	yych = *++cur;
	if (yych == 'C') goto yy274;
	if (yych == 'c') goto yy274;
	goto yy55;
yy156:
	yych = *++cur;
	if (yych == 'T') goto yy275;
	if (yych == 't') goto yy275;
	goto yy55;
yy157:
	yych = *++cur;
	if (yych <= 'F') {
		if (yych == 'A') goto yy276;
		if (yych <= 'E') goto yy55;
		goto yy277;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy276;
		} else {
			if (yych == 'f') goto yy277;
			goto yy55;
		}
	}
yy158:
	yych = *++cur;
	if (yych == 'M') goto yy278;
	if (yych == 'm') goto yy278;
	goto yy55;
yy159:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'W') {
		if (yych <= '@') {
			if (yych <= '/') goto yy160;
			if (yych <= '9') goto yy54;
		} else {
			if (yych == 'U') goto yy279;
			if (yych <= 'V') goto yy54;
			goto yy280;
		}
	} else {
		if (yych <= 'u') {
			if (yych <= 'Z') goto yy54;
			if (yych <= '`') goto yy160;
			if (yych <= 't') goto yy54;
			goto yy279;
		} else {
			if (yych == 'w') goto yy280;
			if (yych <= 'z') goto yy54;
		}
	}
yy160:
#line 212 "tokenizer.re"
	{ KW(DO) }
#line 1561 "tokenizer.cpp"
yy161:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'E') goto yy281;
		if (yych <= 'R') goto yy55;
		goto yy282;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy281;
		} else {
			if (yych == 's') goto yy282;
			goto yy55;
		}
	}
yy162:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'D') {
			if (yych <= 'C') goto yy55;
			goto yy283;
		} else {
			if (yych <= 'S') goto yy55;
			if (yych <= 'T') goto yy285;
			goto yy286;
		}
	} else {
		if (yych <= 's') {
			if (yych == 'd') goto yy283;
			goto yy55;
		} else {
			if (yych <= 't') goto yy285;
			if (yych <= 'u') goto yy286;
			goto yy55;
		}
	}
yy163:
	yych = *++cur;
	if (yych == 'U') goto yy287;
	if (yych == 'u') goto yy287;
	goto yy55;
yy164:
	yych = *++cur;
	if (yych == 'R') goto yy288;
	if (yych == 'r') goto yy288;
	goto yy55;
yy165:
	yych = *++cur;
	if (yych == 'E') goto yy289;
	if (yych == 'e') goto yy289;
	goto yy55;
yy166:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'I') goto yy290;
		if (yych <= 'S') goto yy55;
		goto yy291;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy290;
		} else {
			if (yych == 't') goto yy291;
			goto yy55;
		}
	}
yy167:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'L') goto yy292;
		if (yych <= 'M') goto yy55;
		goto yy293;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy292;
		} else {
			if (yych == 'n') goto yy293;
			goto yy55;
		}
	}
yy168:
	yych = *++cur;
	if (yych == 'U') goto yy294;
	if (yych == 'u') goto yy294;
	goto yy55;
yy169:
	yych = *++cur;
	if (yych == 'R') goto yy295;
	if (yych == 'r') goto yy295;
	goto yy55;
yy170:
	yych = *++cur;
	if (yych == 'N') goto yy296;
	if (yych == 'n') goto yy296;
	goto yy55;
yy171:
	yych = *++cur;
	if (yych == 'N') goto yy297;
	if (yych == 'n') goto yy297;
	goto yy55;
yy172:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy173;
			if (yych <= 'S') goto yy54;
			goto yy298;
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 't') goto yy298;
			if (yych <= 'z') goto yy54;
		}
	}
yy173:
#line 308 "tokenizer.re"
	{ KW(GO) }
#line 1688 "tokenizer.cpp"
yy174:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 310 "tokenizer.re"
	{ KW(IF) }
#line 1697 "tokenizer.cpp"
yy176:
	yych = *++cur;
	if (yych == 'P') goto yy299;
	if (yych == 'p') goto yy299;
	goto yy55;
yy177:
	yyaccept = 8;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'O') {
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych == '\t') goto yy300;
			} else {
				if (yych == '\f') goto yy178;
				if (yych <= '\r') goto yy300;
			}
		} else {
			if (yych <= '@') {
				if (yych <= ' ') goto yy300;
				if (yych <= '/') goto yy178;
				if (yych <= '9') goto yy54;
			} else {
				if (yych == 'C') goto yy302;
				if (yych <= 'N') goto yy54;
				goto yy303;
			}
		}
	} else {
		if (yych <= 'c') {
			if (yych <= 'T') {
				if (yych == 'Q') goto yy304;
				if (yych <= 'S') goto yy54;
				goto yy305;
			} else {
				if (yych <= 'Z') goto yy54;
				if (yych <= '`') goto yy178;
				if (yych <= 'b') goto yy54;
				goto yy302;
			}
		} else {
			if (yych <= 'q') {
				if (yych == 'o') goto yy303;
				if (yych <= 'p') goto yy54;
				goto yy304;
			} else {
				if (yych == 't') goto yy305;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy178:
#line 314 "tokenizer.re"
	{ KW(IN) }
#line 1754 "tokenizer.cpp"
yy179:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 323 "tokenizer.re"
	{ KW(IS) }
#line 1763 "tokenizer.cpp"
yy181:
	yych = *++cur;
	if (yych == 'N') goto yy306;
	if (yych == 'n') goto yy306;
	goto yy55;
yy182:
	yych = *++cur;
	if (yych == 'N') goto yy307;
	if (yych == 'n') goto yy307;
	goto yy55;
yy183:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy309;
		if (yych <= 'F') goto yy55;
		goto yy310;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy309;
		} else {
			if (yych == 'g') goto yy310;
			goto yy55;
		}
	}
yy184:
	yych = *++cur;
	if (yych <= 'L') {
		if (yych == 'D') goto yy311;
		if (yych <= 'K') goto yy55;
		goto yy312;
	} else {
		if (yych <= 'd') {
			if (yych <= 'c') goto yy55;
			goto yy311;
		} else {
			if (yych == 'l') goto yy312;
			goto yy55;
		}
	}
yy185:
	yych = *++cur;
	if (yych == 'M') goto yy313;
	if (yych == 'm') goto yy313;
	goto yy55;
yy186:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == 'N') goto yy314;
		if (yych <= 'O') goto yy55;
		goto yy315;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy314;
		} else {
			if (yych == 'p') goto yy315;
			goto yy55;
		}
	}
yy187:
	yych = *++cur;
	if (yych == 'L') goto yy316;
	if (yych == 'l') goto yy316;
	goto yy55;
yy188:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy317;
	}
	goto yy79;
yy189:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '7') goto yy319;
	goto yy79;
yy190:
	yych = *++cur;
	if (yych == 'L') goto yy321;
	if (yych == 'l') goto yy321;
	goto yy55;
yy191:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy322;
		if (yych <= 'S') goto yy55;
		goto yy323;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy322;
		} else {
			if (yych == 't') goto yy323;
			goto yy55;
		}
	}
yy192:
	yych = *++cur;
	if (yych == 'T') goto yy324;
	if (yych == 't') goto yy324;
	goto yy55;
yy193:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'Q') goto yy55;
		if (yych <= 'R') goto yy326;
		goto yy327;
	} else {
		if (yych <= 'q') goto yy55;
		if (yych <= 'r') goto yy326;
		if (yych <= 's') goto yy327;
		goto yy55;
	}
yy194:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'I') goto yy328;
		if (yych <= 'R') goto yy55;
		goto yy329;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy328;
		} else {
			if (yych == 's') goto yy329;
			goto yy55;
		}
	}
yy195:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych <= 'H') {
			if (yych == 'E') goto yy330;
			goto yy55;
		} else {
			if (yych <= 'I') goto yy331;
			if (yych <= 'N') goto yy55;
			goto yy332;
		}
	} else {
		if (yych <= 'h') {
			if (yych == 'e') goto yy330;
			goto yy55;
		} else {
			if (yych <= 'i') goto yy331;
			if (yych == 'o') goto yy332;
			goto yy55;
		}
	}
yy196:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'B') goto yy333;
		if (yych <= 'Q') goto yy55;
		goto yy334;
	} else {
		if (yych <= 'b') {
			if (yych <= 'a') goto yy55;
			goto yy333;
		} else {
			if (yych == 'r') goto yy334;
			goto yy55;
		}
	}
yy197:
	yych = *++cur;
	if (yych == 'I') goto yy335;
	if (yych == 'i') goto yy335;
	goto yy55;
yy198:
	yych = *++cur;
	if (yych == 'N') goto yy336;
	if (yych == 'n') goto yy336;
	goto yy55;
yy199:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy337;
	case 'C':
	case 'c':	goto yy338;
	case 'D':
	case 'd':	goto yy339;
	case 'S':
	case 's':	goto yy340;
	case 'T':
	case 't':	goto yy341;
	case 'W':
	case 'w':	goto yy342;
	default:	goto yy55;
	}
yy200:
	yych = *++cur;
	if (yych == 'V') goto yy343;
	if (yych == 'v') goto yy343;
	goto yy55;
yy201:
	yych = *++cur;
	if (yych <= 'Q') {
		if (yych == 'L') goto yy344;
		if (yych <= 'P') goto yy55;
		goto yy345;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy344;
		} else {
			if (yych == 'q') goto yy345;
			goto yy55;
		}
	}
yy202:
	yych = *++cur;
	if (yych == 'A') goto yy346;
	if (yych == 'a') goto yy346;
	goto yy55;
yy203:
	yych = *++cur;
	if (yych == 'U') goto yy347;
	if (yych == 'u') goto yy347;
	goto yy55;
yy204:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy348;
		if (yych <= 'N') goto yy55;
		goto yy349;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy348;
		} else {
			if (yych == 'o') goto yy349;
			goto yy55;
		}
	}
yy205:
	yych = *++cur;
	if (yych == 'B') goto yy350;
	if (yych == 'b') goto yy350;
	goto yy55;
yy206:
	yych = *++cur;
	if (yych == 'N') goto yy351;
	if (yych == 'n') goto yy351;
	goto yy55;
yy207:
	yych = *++cur;
	if (yych == 'R') goto yy352;
	if (yych == 'r') goto yy352;
	goto yy55;
yy208:
	yych = *++cur;
	if (yych == 'A') goto yy353;
	if (yych == 'a') goto yy353;
	goto yy55;
yy209:
	yych = *++cur;
	if (yych == 'E') goto yy354;
	if (yych == 'e') goto yy354;
	goto yy55;
yy210:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 382 "tokenizer.re"
	{ KW(TO) }
#line 2033 "tokenizer.cpp"
yy212:
	yych = *++cur;
	if (yych == 'P') goto yy355;
	if (yych == 'p') goto yy355;
	goto yy55;
yy213:
	yych = *++cur;
	if (yych == 'F') goto yy356;
	if (yych == 'f') goto yy356;
	goto yy55;
yy214:
	yych = *++cur;
	if (yych == 'E') goto yy357;
	if (yych == 'e') goto yy357;
	goto yy55;
yy215:
	yych = *++cur;
	if (yych == 'L') goto yy359;
	if (yych == 'l') goto yy359;
	goto yy55;
yy216:
	yych = *++cur;
	if (yych == 'L') goto yy360;
	if (yych == 'l') goto yy360;
	goto yy55;
yy217:
	yych = *++cur;
	if (yych == 'I') goto yy361;
	if (yych == 'i') goto yy361;
	goto yy55;
yy218:
	yych = *++cur;
	if (yych <= 'I') {
		if (yych == 'E') goto yy362;
		if (yych <= 'H') goto yy55;
		goto yy363;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy362;
		} else {
			if (yych == 'i') goto yy363;
			goto yy55;
		}
	}
yy219:
	yych = *++cur;
	if (yych == 'I') goto yy364;
	if (yych == 'i') goto yy364;
	goto yy55;
yy220:
	yych = *++cur;
	if (yych == '"') goto yy79;
	goto yy366;
yy221:
	yych = *++cur;
	if (yych == '\'') goto yy79;
	goto yy368;
yy222:
	++cur;
	goto yy94;
yy223:
	yych = *++cur;
	if (yych == ')') goto yy369;
	goto yy79;
yy224:
	++cur;
	cur -= 2;
#line 402 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 2104 "tokenizer.cpp"
yy226:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy371;
		if (yych <= '@') goto yy79;
		goto yy373;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy373;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy373;
			goto yy79;
		}
	}
yy227:
	++cur;
#line 509 "tokenizer.re"
	{ token(yylval.string); RET(TK_DEF_OP) }
#line 2126 "tokenizer.cpp"
yy229:
	yych = *++cur;
	if (yych == 'D') goto yy375;
	if (yych == 'd') goto yy375;
	goto yy111;
yy230:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == '.') goto yy134;
		goto yy111;
	} else {
		if (yych <= 'V') goto yy376;
		if (yych == 'v') goto yy376;
		goto yy111;
	}
yy231:
	yych = *++cur;
	if (yych == 'L') goto yy377;
	if (yych == 'l') goto yy377;
	goto yy111;
yy232:
	yych = *++cur;
	if (yych == '.') goto yy138;
	goto yy111;
yy233:
	yych = *++cur;
	if (yych == '.') goto yy378;
	goto yy111;
yy234:
	yych = *++cur;
	if (yych == '.') goto yy132;
	goto yy111;
yy235:
	yych = *++cur;
	if (yych == '.') goto yy379;
	goto yy111;
yy236:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == '.') goto yy123;
		goto yy111;
	} else {
		if (yych <= 'Q') goto yy380;
		if (yych == 'q') goto yy380;
		goto yy111;
	}
yy237:
	yych = *++cur;
	if (yych == 'T') goto yy381;
	if (yych == 't') goto yy381;
	goto yy111;
yy238:
	yych = *++cur;
	if (yych == '.') goto yy382;
	goto yy111;
yy239:
	yych = *++cur;
	if (yych == 'U') goto yy384;
	if (yych == 'u') goto yy384;
	goto yy111;
yy240:
	yych = *++cur;
	if (yybm[0+yych] & 16) {
		goto yy240;
	}
	cur = ctxmar;
#line 460 "tokenizer.re"
	{
                if (last_token == yytokentype::TK_NEWLINE) {
                    uint64_t u;
                    if (lex_int(tok, cur, u, yylval.int_suffix.int_kind)) {
                            yylval.n = u;
                            RET(TK_LABEL)
                    } else {
                        token_loc(loc);
                        std::string t = token();
                        throw LFortran::TokenizerError("Integer too large",
                            loc, t);
                    }
                } else {
                    lex_int_large(al, tok, cur,
                        yylval.int_suffix.int_n,
                        yylval.int_suffix.int_kind);
                    RET(TK_INTEGER)
                }
            }
#line 2213 "tokenizer.cpp"
yy243:
	yych = *++cur;
yy244:
	if (yych <= '@') {
		if (yych == '.') goto yy385;
		goto yy79;
	} else {
		if (yych <= 'Z') goto yy243;
		if (yych <= '`') goto yy79;
		if (yych <= 'z') goto yy243;
		goto yy79;
	}
yy245:
	yych = *++cur;
	if (yych <= ',') {
		if (yych != '+') goto yy244;
	} else {
		if (yych <= '-') goto yy246;
		if (yych <= '/') goto yy244;
		if (yych <= '9') goto yy247;
		goto yy244;
	}
yy246:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych >= ':') goto yy79;
yy247:
	yyaccept = 7;
	yych = *(mar = ++cur);
	if (yych <= '/') goto yy108;
	if (yych <= '9') goto yy247;
	if (yych == '_') goto yy226;
	goto yy108;
yy249:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			goto yy35;
		} else {
			if (yych == '\f') goto yy35;
			ctxmar = cur;
			goto yy125;
		}
	} else {
		if (yych <= '-') {
			if (yych == ' ') {
				ctxmar = cur;
				goto yy125;
			}
			goto yy35;
		} else {
			if (yych <= '.') {
				ctxmar = cur;
				goto yy387;
			}
			if (yych <= '/') goto yy35;
			if (yych <= '9') goto yy249;
			goto yy35;
		}
	}
yy251:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= '-') {
		if (yych <= '\v') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych <= '\n') goto yy35;
			ctxmar = cur;
			goto yy125;
		} else {
			if (yych <= '\r') {
				if (yych <= '\f') goto yy35;
				ctxmar = cur;
				goto yy125;
			} else {
				if (yych == ' ') {
					ctxmar = cur;
					goto yy125;
				}
				goto yy35;
			}
		}
	} else {
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych <= '.') {
					ctxmar = cur;
					goto yy387;
				}
				goto yy35;
			} else {
				if (yych <= '9') goto yy251;
				if (yych <= '@') goto yy35;
				goto yy251;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy35;
				goto yy251;
			} else {
				if (yych <= '`') goto yy35;
				if (yych <= 'z') goto yy251;
				goto yy35;
			}
		}
	}
yy253:
	yych = *++cur;
	if (yych == 'T') goto yy388;
	if (yych == 't') goto yy388;
	goto yy55;
yy254:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'O') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy255;
			if (yych <= 'N') goto yy54;
			goto yy389;
		}
	} else {
		if (yych <= 'n') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'o') goto yy389;
			if (yych <= 'z') goto yy54;
		}
	}
yy255:
#line 184 "tokenizer.re"
	{ KW(ALL) }
#line 2358 "tokenizer.cpp"
yy256:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'I') goto yy390;
		if (yych <= 'N') goto yy55;
		goto yy391;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy390;
		} else {
			if (yych == 'o') goto yy391;
			goto yy55;
		}
	}
yy257:
	yych = *++cur;
	if (yych == 'N') goto yy392;
	if (yych == 'n') goto yy392;
	goto yy55;
yy258:
	yych = *++cur;
	if (yybm[0+yych] & 32) {
		goto yy258;
	}
	if (yych == '"') goto yy393;
	goto yy79;
yy260:
	yych = *++cur;
	if (yych == '\'') goto yy395;
	if (yych <= '/') goto yy79;
	if (yych <= '1') goto yy260;
	goto yy79;
yy262:
	yych = *++cur;
	if (yych == 'K') goto yy397;
	if (yych == 'k') goto yy397;
	goto yy55;
yy263:
	yych = *++cur;
	if (yych == 'D') goto yy398;
	if (yych == 'd') goto yy398;
	goto yy55;
yy264:
	yych = *++cur;
	if (yych == 'C') goto yy400;
	if (yych == 'c') goto yy400;
	goto yy55;
yy265:
	yych = *++cur;
	if (yych == 'L') goto yy401;
	if (yych == 'l') goto yy401;
	goto yy55;
yy266:
	yych = *++cur;
	if (yych == 'E') goto yy403;
	if (yych == 'e') goto yy403;
	goto yy55;
yy267:
	yych = *++cur;
	if (yych == 'R') goto yy405;
	if (yych == 'r') goto yy405;
	goto yy55;
yy268:
	yych = *++cur;
	if (yych == 'S') goto yy406;
	if (yych == 's') goto yy406;
	goto yy55;
yy269:
	yych = *++cur;
	if (yych == 'S') goto yy407;
	if (yych == 's') goto yy407;
	goto yy55;
yy270:
	yych = *++cur;
	if (yych == 'I') goto yy408;
	if (yych == 'i') goto yy408;
	goto yy55;
yy271:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == 'M') goto yy409;
		if (yych <= 'O') goto yy55;
		goto yy410;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy409;
		} else {
			if (yych == 'p') goto yy410;
			goto yy55;
		}
	}
yy272:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'C') goto yy411;
		if (yych <= 'S') goto yy55;
		goto yy412;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy411;
		} else {
			if (yych == 't') goto yy412;
			goto yy55;
		}
	}
yy273:
	yych = *++cur;
	if (yych == 'T') goto yy413;
	if (yych == 't') goto yy413;
	goto yy55;
yy274:
	yych = *++cur;
	if (yych == 'L') goto yy414;
	if (yych == 'l') goto yy414;
	goto yy55;
yy275:
	yych = *++cur;
	if (yych == 'A') goto yy415;
	if (yych == 'a') goto yy415;
	goto yy55;
yy276:
	yych = *++cur;
	if (yych == 'L') goto yy417;
	if (yych == 'l') goto yy417;
	goto yy55;
yy277:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy418;
		if (yych <= 'D') goto yy55;
		goto yy419;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy418;
		} else {
			if (yych == 'e') goto yy419;
			goto yy55;
		}
	}
yy278:
	yych = *++cur;
	if (yych == 'E') goto yy420;
	if (yych == 'e') goto yy420;
	goto yy55;
yy279:
	yych = *++cur;
	if (yych == 'B') goto yy421;
	if (yych == 'b') goto yy421;
	goto yy55;
yy280:
	yych = *++cur;
	if (yych == 'H') goto yy422;
	if (yych == 'h') goto yy422;
	goto yy55;
yy281:
	yych = *++cur;
	if (yych == 'M') goto yy423;
	if (yych == 'm') goto yy423;
	goto yy55;
yy282:
	yych = *++cur;
	if (yych == 'E') goto yy424;
	if (yych == 'e') goto yy424;
	goto yy55;
yy283:
	yyaccept = 9;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':	goto yy426;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'G':
	case 'H':
	case 'J':
	case 'K':
	case 'L':
	case 'N':
	case 'O':
	case 'Q':
	case 'R':
	case 'U':
	case 'V':
	case 'X':
	case 'Y':
	case 'Z':
	case 'g':
	case 'h':
	case 'j':
	case 'k':
	case 'l':
	case 'n':
	case 'o':
	case 'q':
	case 'r':
	case 'u':
	case 'v':
	case 'x':
	case 'y':
	case 'z':	goto yy54;
	case 'A':
	case 'a':	goto yy428;
	case 'B':
	case 'b':	goto yy429;
	case 'C':
	case 'c':	goto yy430;
	case 'D':
	case 'd':	goto yy431;
	case 'E':
	case 'e':	goto yy432;
	case 'F':
	case 'f':	goto yy433;
	case 'I':
	case 'i':	goto yy434;
	case 'M':
	case 'm':	goto yy435;
	case 'P':
	case 'p':	goto yy436;
	case 'S':
	case 's':	goto yy437;
	case 'T':
	case 't':	goto yy438;
	case 'W':
	case 'w':	goto yy439;
	default:	goto yy284;
	}
yy284:
#line 221 "tokenizer.re"
	{ KW(END) }
#line 2605 "tokenizer.cpp"
yy285:
	yych = *++cur;
	if (yych == 'R') goto yy440;
	if (yych == 'r') goto yy440;
	goto yy55;
yy286:
	yych = *++cur;
	if (yych == 'M') goto yy441;
	if (yych == 'm') goto yy441;
	goto yy55;
yy287:
	yych = *++cur;
	if (yych == 'I') goto yy443;
	if (yych == 'i') goto yy443;
	goto yy55;
yy288:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'M') goto yy444;
		if (yych <= 'N') goto yy55;
		goto yy445;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy444;
		} else {
			if (yych == 'o') goto yy445;
			goto yy55;
		}
	}
yy289:
	yych = *++cur;
	if (yych == 'N') goto yy446;
	if (yych == 'n') goto yy446;
	goto yy55;
yy290:
	yych = *++cur;
	if (yych == 'T') goto yy447;
	if (yych == 't') goto yy447;
	goto yy55;
yy291:
	yych = *++cur;
	if (yych == 'E') goto yy449;
	if (yych == 'e') goto yy449;
	goto yy55;
yy292:
	yych = *++cur;
	if (yych == 'E') goto yy450;
	if (yych == 'e') goto yy450;
	goto yy55;
yy293:
	yych = *++cur;
	if (yych == 'A') goto yy452;
	if (yych == 'a') goto yy452;
	goto yy55;
yy294:
	yych = *++cur;
	if (yych == 'S') goto yy453;
	if (yych == 's') goto yy453;
	goto yy55;
yy295:
	yych = *++cur;
	if (yych <= 'M') {
		if (yych == 'A') goto yy454;
		if (yych <= 'L') goto yy55;
		goto yy455;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy454;
		} else {
			if (yych == 'm') goto yy455;
			goto yy55;
		}
	}
yy296:
	yych = *++cur;
	if (yych == 'C') goto yy456;
	if (yych == 'c') goto yy456;
	goto yy55;
yy297:
	yych = *++cur;
	if (yych == 'E') goto yy457;
	if (yych == 'e') goto yy457;
	goto yy55;
yy298:
	yych = *++cur;
	if (yych == 'O') goto yy458;
	if (yych == 'o') goto yy458;
	goto yy55;
yy299:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'L') goto yy460;
			goto yy55;
		} else {
			if (yych <= 'O') goto yy461;
			if (yych <= 'T') goto yy55;
			goto yy462;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'l') goto yy460;
			goto yy55;
		} else {
			if (yych <= 'o') goto yy461;
			if (yych == 'u') goto yy462;
			goto yy55;
		}
	}
yy300:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy300;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy300;
		}
	} else {
		if (yych <= 'N') {
			if (yych == ' ') goto yy300;
			goto yy79;
		} else {
			if (yych <= 'O') goto yy463;
			if (yych == 'o') goto yy463;
			goto yy79;
		}
	}
yy302:
	yych = *++cur;
	if (yych == 'L') goto yy464;
	if (yych == 'l') goto yy464;
	goto yy55;
yy303:
	yych = *++cur;
	if (yych == 'U') goto yy465;
	if (yych == 'u') goto yy465;
	goto yy55;
yy304:
	yych = *++cur;
	if (yych == 'U') goto yy466;
	if (yych == 'u') goto yy466;
	goto yy55;
yy305:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'E') goto yy467;
		if (yych <= 'Q') goto yy55;
		goto yy468;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy467;
		} else {
			if (yych == 'r') goto yy468;
			goto yy55;
		}
	}
yy306:
	yych = *++cur;
	if (yych == 'D') goto yy469;
	if (yych == 'd') goto yy469;
	goto yy55;
yy307:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 325 "tokenizer.re"
	{ KW(LEN) }
#line 2780 "tokenizer.cpp"
yy309:
	yych = *++cur;
	if (yych == 'A') goto yy471;
	if (yych == 'a') goto yy471;
	goto yy55;
yy310:
	yych = *++cur;
	if (yych == 'I') goto yy472;
	if (yych == 'i') goto yy472;
	goto yy55;
yy311:
	yych = *++cur;
	if (yych == 'U') goto yy473;
	if (yych == 'u') goto yy473;
	goto yy55;
yy312:
	yych = *++cur;
	if (yych == 'D') goto yy474;
	if (yych == 'd') goto yy474;
	goto yy55;
yy313:
	yych = *++cur;
	if (yych == 'E') goto yy476;
	if (yych == 'e') goto yy476;
	goto yy55;
yy314:
	yych = *++cur;
	if (yych <= '^') {
		if (yych == 'E') goto yy478;
		goto yy55;
	} else {
		if (yych <= '_') goto yy480;
		if (yych == 'e') goto yy478;
		goto yy55;
	}
yy315:
	yych = *++cur;
	if (yych == 'A') goto yy481;
	if (yych == 'a') goto yy481;
	goto yy55;
yy316:
	yych = *++cur;
	if (yych == 'L') goto yy482;
	if (yych == 'l') goto yy482;
	goto yy55;
yy317:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy317;
	}
	if (yych == '"') goto yy483;
	goto yy79;
yy319:
	yych = *++cur;
	if (yych == '\'') goto yy485;
	if (yych <= '/') goto yy79;
	if (yych <= '7') goto yy319;
	goto yy79;
yy321:
	yych = *++cur;
	if (yych == 'Y') goto yy487;
	if (yych == 'y') goto yy487;
	goto yy55;
yy322:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'N') goto yy489;
		if (yych <= 'Q') goto yy55;
		goto yy491;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy489;
		} else {
			if (yych == 'r') goto yy491;
			goto yy55;
		}
	}
yy323:
	yych = *++cur;
	if (yych == 'I') goto yy492;
	if (yych == 'i') goto yy492;
	goto yy55;
yy324:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 343 "tokenizer.re"
	{ KW(OUT) }
#line 2872 "tokenizer.cpp"
yy326:
	yych = *++cur;
	if (yych == 'A') goto yy493;
	if (yych == 'a') goto yy493;
	goto yy55;
yy327:
	yych = *++cur;
	if (yych == 'S') goto yy494;
	if (yych == 's') goto yy494;
	goto yy55;
yy328:
	yych = *++cur;
	if (yych == 'N') goto yy496;
	if (yych == 'n') goto yy496;
	goto yy55;
yy329:
	yych = *++cur;
	if (yych == 'T') goto yy497;
	if (yych == 't') goto yy497;
	goto yy55;
yy330:
	yych = *++cur;
	if (yych == 'C') goto yy499;
	if (yych == 'c') goto yy499;
	goto yy55;
yy331:
	yych = *++cur;
	if (yych <= 'V') {
		if (yych == 'N') goto yy500;
		if (yych <= 'U') goto yy55;
		goto yy501;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy500;
		} else {
			if (yych == 'v') goto yy501;
			goto yy55;
		}
	}
yy332:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych <= 'F') {
			if (yych == 'C') goto yy502;
			goto yy55;
		} else {
			if (yych <= 'G') goto yy503;
			if (yych <= 'S') goto yy55;
			goto yy504;
		}
	} else {
		if (yych <= 'f') {
			if (yych == 'c') goto yy502;
			goto yy55;
		} else {
			if (yych <= 'g') goto yy503;
			if (yych == 't') goto yy504;
			goto yy55;
		}
	}
yy333:
	yych = *++cur;
	if (yych == 'L') goto yy505;
	if (yych == 'l') goto yy505;
	goto yy55;
yy334:
	yych = *++cur;
	if (yych == 'E') goto yy506;
	if (yych == 'e') goto yy506;
	goto yy55;
yy335:
	yych = *++cur;
	if (yych == 'E') goto yy508;
	if (yych == 'e') goto yy508;
	goto yy55;
yy336:
	yych = *++cur;
	if (yych == 'K') goto yy509;
	if (yych == 'k') goto yy509;
	goto yy55;
yy337:
	yych = *++cur;
	if (yych <= 'L') {
		if (yych == 'D') goto yy511;
		if (yych <= 'K') goto yy55;
		goto yy513;
	} else {
		if (yych <= 'd') {
			if (yych <= 'c') goto yy55;
			goto yy511;
		} else {
			if (yych == 'l') goto yy513;
			goto yy55;
		}
	}
yy338:
	yych = *++cur;
	if (yych == 'U') goto yy515;
	if (yych == 'u') goto yy515;
	goto yy55;
yy339:
	yych = *++cur;
	if (yych == 'U') goto yy516;
	if (yych == 'u') goto yy516;
	goto yy55;
yy340:
	yych = *++cur;
	if (yych == 'U') goto yy517;
	if (yych == 'u') goto yy517;
	goto yy55;
yy341:
	yych = *++cur;
	if (yych == 'U') goto yy518;
	if (yych == 'u') goto yy518;
	goto yy55;
yy342:
	yych = *++cur;
	if (yych == 'I') goto yy519;
	if (yych == 'i') goto yy519;
	goto yy55;
yy343:
	yych = *++cur;
	if (yych == 'E') goto yy520;
	if (yych == 'e') goto yy520;
	goto yy55;
yy344:
	yych = *++cur;
	if (yych == 'E') goto yy522;
	if (yych == 'e') goto yy522;
	goto yy55;
yy345:
	yych = *++cur;
	if (yych == 'U') goto yy523;
	if (yych == 'u') goto yy523;
	goto yy55;
yy346:
	yych = *++cur;
	if (yych == 'R') goto yy524;
	if (yych == 'r') goto yy524;
	goto yy55;
yy347:
	yych = *++cur;
	if (yych == 'R') goto yy525;
	if (yych == 'r') goto yy525;
	goto yy55;
yy348:
	yych = *++cur;
	if (yych == 'T') goto yy526;
	if (yych == 't') goto yy526;
	goto yy55;
yy349:
	yych = *++cur;
	if (yych == 'P') goto yy528;
	if (yych == 'p') goto yy528;
	goto yy55;
yy350:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy530;
		if (yych <= 'Q') goto yy55;
		goto yy531;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy530;
		} else {
			if (yych == 'r') goto yy531;
			goto yy55;
		}
	}
yy351:
	yych = *++cur;
	if (yych == 'C') goto yy532;
	if (yych == 'c') goto yy532;
	goto yy55;
yy352:
	yych = *++cur;
	if (yych == 'G') goto yy534;
	if (yych == 'g') goto yy534;
	goto yy55;
yy353:
	yych = *++cur;
	if (yych == 'M') goto yy535;
	if (yych == 'm') goto yy535;
	goto yy55;
yy354:
	yych = *++cur;
	if (yych == 'N') goto yy537;
	if (yych == 'n') goto yy537;
	goto yy55;
yy355:
	yych = *++cur;
	if (yych == 'E') goto yy539;
	if (yych == 'e') goto yy539;
	goto yy55;
yy356:
	yych = *++cur;
	if (yych == 'O') goto yy541;
	if (yych == 'o') goto yy541;
	goto yy55;
yy357:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 385 "tokenizer.re"
	{ KW(USE) }
#line 3082 "tokenizer.cpp"
yy359:
	yych = *++cur;
	if (yych == 'U') goto yy542;
	if (yych == 'u') goto yy542;
	goto yy55;
yy360:
	yych = *++cur;
	if (yych == 'A') goto yy543;
	if (yych == 'a') goto yy543;
	goto yy55;
yy361:
	yych = *++cur;
	if (yych == 'T') goto yy544;
	if (yych == 't') goto yy544;
	goto yy55;
yy362:
	yych = *++cur;
	if (yych == 'R') goto yy546;
	if (yych == 'r') goto yy546;
	goto yy55;
yy363:
	yych = *++cur;
	if (yych == 'L') goto yy547;
	if (yych == 'l') goto yy547;
	goto yy55;
yy364:
	yych = *++cur;
	if (yych == 'T') goto yy548;
	if (yych == 't') goto yy548;
	goto yy55;
yy365:
	yych = *++cur;
yy366:
	if (yybm[0+yych] & 128) {
		goto yy365;
	}
	if (yych == '"') goto yy549;
	goto yy79;
yy367:
	yych = *++cur;
yy368:
	if (yych <= '9') {
		if (yych == '\'') goto yy551;
		if (yych <= '/') goto yy79;
		goto yy367;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy79;
			goto yy367;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'f') goto yy367;
			goto yy79;
		}
	}
yy369:
	++cur;
	cur -= 3;
#line 403 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 3143 "tokenizer.cpp"
yy371:
	yych = *++cur;
	if (yych <= '/') goto yy108;
	if (yych <= '9') goto yy371;
	goto yy108;
yy373:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy108;
		if (yych <= '9') goto yy373;
		if (yych <= '@') goto yy108;
		goto yy373;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy108;
			goto yy373;
		} else {
			if (yych <= '`') goto yy108;
			if (yych <= 'z') goto yy373;
			goto yy108;
		}
	}
yy375:
	yych = *++cur;
	if (yych == '.') goto yy553;
	goto yy111;
yy376:
	yych = *++cur;
	if (yych == '.') goto yy555;
	goto yy111;
yy377:
	yych = *++cur;
	if (yych == 'S') goto yy557;
	if (yych == 's') goto yy557;
	goto yy111;
yy378:
	++cur;
	goto yy45;
yy379:
	++cur;
	goto yy41;
yy380:
	yych = *++cur;
	if (yych == 'V') goto yy558;
	if (yych == 'v') goto yy558;
	goto yy111;
yy381:
	yych = *++cur;
	if (yych == '.') goto yy559;
	goto yy111;
yy382:
	++cur;
#line 437 "tokenizer.re"
	{ RET(TK_OR) }
#line 3198 "tokenizer.cpp"
yy384:
	yych = *++cur;
	if (yych == 'E') goto yy561;
	if (yych == 'e') goto yy561;
	goto yy111;
yy385:
	++cur;
	cur = ctxmar;
#line 451 "tokenizer.re"
	{
                lex_int_large(al, tok, cur,
                    yylval.int_suffix.int_n,
                    yylval.int_suffix.int_kind);
                RET(TK_INTEGER)
            }
#line 3214 "tokenizer.cpp"
yy387:
	yych = *++cur;
	if (yych == '.') goto yy79;
	goto yy244;
yy388:
	yych = *++cur;
	if (yych == 'R') goto yy562;
	if (yych == 'r') goto yy562;
	goto yy55;
yy389:
	yych = *++cur;
	if (yych == 'C') goto yy563;
	if (yych == 'c') goto yy563;
	goto yy55;
yy390:
	yych = *++cur;
	if (yych == 'G') goto yy564;
	if (yych == 'g') goto yy564;
	goto yy55;
yy391:
	yych = *++cur;
	if (yych == 'C') goto yy565;
	if (yych == 'c') goto yy565;
	goto yy55;
yy392:
	yych = *++cur;
	if (yych == 'C') goto yy566;
	if (yych == 'c') goto yy566;
	goto yy55;
yy393:
	++cur;
#line 486 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3248 "tokenizer.cpp"
yy395:
	++cur;
#line 487 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3253 "tokenizer.cpp"
yy397:
	yych = *++cur;
	if (yych == 'S') goto yy567;
	if (yych == 's') goto yy567;
	goto yy55;
yy398:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 191 "tokenizer.re"
	{ KW(BIND) }
#line 3267 "tokenizer.cpp"
yy400:
	yych = *++cur;
	if (yych == 'K') goto yy568;
	if (yych == 'k') goto yy568;
	goto yy55;
yy401:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 193 "tokenizer.re"
	{ KW(CALL) }
#line 3281 "tokenizer.cpp"
yy403:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 194 "tokenizer.re"
	{ KW(CASE) }
#line 3290 "tokenizer.cpp"
yy405:
	yych = *++cur;
	if (yych == 'A') goto yy570;
	if (yych == 'a') goto yy570;
	goto yy55;
yy406:
	yych = *++cur;
	if (yych == 'S') goto yy571;
	if (yych == 's') goto yy571;
	goto yy55;
yy407:
	yych = *++cur;
	if (yych == 'E') goto yy573;
	if (yych == 'e') goto yy573;
	goto yy55;
yy408:
	yych = *++cur;
	if (yych == 'M') goto yy575;
	if (yych == 'm') goto yy575;
	goto yy55;
yy409:
	yych = *++cur;
	if (yych == 'O') goto yy576;
	if (yych == 'o') goto yy576;
	goto yy55;
yy410:
	yych = *++cur;
	if (yych == 'L') goto yy577;
	if (yych == 'l') goto yy577;
	goto yy55;
yy411:
	yych = *++cur;
	if (yych == 'U') goto yy578;
	if (yych == 'u') goto yy578;
	goto yy55;
yy412:
	yych = *++cur;
	if (yych <= 'I') {
		if (yych == 'A') goto yy579;
		if (yych <= 'H') goto yy55;
		goto yy580;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy579;
		} else {
			if (yych == 'i') goto yy580;
			goto yy55;
		}
	}
yy413:
	yych = *++cur;
	if (yych == 'I') goto yy581;
	if (yych == 'i') goto yy581;
	goto yy55;
yy414:
	yych = *++cur;
	if (yych == 'E') goto yy582;
	if (yych == 'e') goto yy582;
	goto yy55;
yy415:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 207 "tokenizer.re"
	{ KW(DATA) }
#line 3359 "tokenizer.cpp"
yy417:
	yych = *++cur;
	if (yych == 'L') goto yy584;
	if (yych == 'l') goto yy584;
	goto yy55;
yy418:
	yych = *++cur;
	if (yych == 'U') goto yy585;
	if (yych == 'u') goto yy585;
	goto yy55;
yy419:
	yych = *++cur;
	if (yych == 'R') goto yy586;
	if (yych == 'r') goto yy586;
	goto yy55;
yy420:
	yych = *++cur;
	if (yych == 'N') goto yy587;
	if (yych == 'n') goto yy587;
	goto yy55;
yy421:
	yych = *++cur;
	if (yych == 'L') goto yy588;
	if (yych == 'l') goto yy588;
	goto yy55;
yy422:
	yych = *++cur;
	if (yych == 'I') goto yy589;
	if (yych == 'i') goto yy589;
	goto yy55;
yy423:
	yych = *++cur;
	if (yych == 'E') goto yy590;
	if (yych == 'e') goto yy590;
	goto yy55;
yy424:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'W') {
		if (yych <= '@') {
			if (yych <= '/') goto yy425;
			if (yych <= '9') goto yy54;
		} else {
			if (yych == 'I') goto yy591;
			if (yych <= 'V') goto yy54;
			goto yy592;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'Z') goto yy54;
			if (yych <= '`') goto yy425;
			if (yych <= 'h') goto yy54;
			goto yy591;
		} else {
			if (yych == 'w') goto yy592;
			if (yych <= 'z') goto yy54;
		}
	}
yy425:
#line 217 "tokenizer.re"
	{ KW(ELSE) }
#line 3423 "tokenizer.cpp"
yy426:
	yych = *++cur;
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':	goto yy426;
	case 'A':
	case 'a':	goto yy593;
	case 'B':
	case 'b':	goto yy594;
	case 'C':
	case 'c':	goto yy595;
	case 'D':
	case 'd':	goto yy596;
	case 'E':
	case 'e':	goto yy597;
	case 'F':
	case 'f':	goto yy598;
	case 'I':
	case 'i':	goto yy599;
	case 'M':
	case 'm':	goto yy600;
	case 'P':
	case 'p':	goto yy601;
	case 'S':
	case 's':	goto yy602;
	case 'T':
	case 't':	goto yy603;
	case 'W':
	case 'w':	goto yy604;
	default:	goto yy79;
	}
yy428:
	yych = *++cur;
	if (yych == 'S') goto yy605;
	if (yych == 's') goto yy605;
	goto yy55;
yy429:
	yych = *++cur;
	if (yych == 'L') goto yy606;
	if (yych == 'l') goto yy606;
	goto yy55;
yy430:
	yych = *++cur;
	if (yych == 'R') goto yy607;
	if (yych == 'r') goto yy607;
	goto yy55;
yy431:
	yych = *++cur;
	if (yych == 'O') goto yy608;
	if (yych == 'o') goto yy608;
	goto yy55;
yy432:
	yych = *++cur;
	if (yych == 'N') goto yy610;
	if (yych == 'n') goto yy610;
	goto yy55;
yy433:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'O') goto yy611;
		if (yych <= 'T') goto yy55;
		goto yy612;
	} else {
		if (yych <= 'o') {
			if (yych <= 'n') goto yy55;
			goto yy611;
		} else {
			if (yych == 'u') goto yy612;
			goto yy55;
		}
	}
yy434:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'F') goto yy613;
		if (yych <= 'M') goto yy55;
		goto yy615;
	} else {
		if (yych <= 'f') {
			if (yych <= 'e') goto yy55;
			goto yy613;
		} else {
			if (yych == 'n') goto yy615;
			goto yy55;
		}
	}
yy435:
	yych = *++cur;
	if (yych == 'O') goto yy616;
	if (yych == 'o') goto yy616;
	goto yy55;
yy436:
	yych = *++cur;
	if (yych == 'R') goto yy617;
	if (yych == 'r') goto yy617;
	goto yy55;
yy437:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'E') goto yy618;
		if (yych <= 'T') goto yy55;
		goto yy619;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy618;
		} else {
			if (yych == 'u') goto yy619;
			goto yy55;
		}
	}
yy438:
	yych = *++cur;
	if (yych == 'Y') goto yy620;
	if (yych == 'y') goto yy620;
	goto yy55;
yy439:
	yych = *++cur;
	if (yych == 'H') goto yy621;
	if (yych == 'h') goto yy621;
	goto yy55;
yy440:
	yych = *++cur;
	if (yych == 'Y') goto yy622;
	if (yych == 'y') goto yy622;
	goto yy55;
yy441:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'E') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy442;
			if (yych <= 'D') goto yy54;
			goto yy624;
		}
	} else {
		if (yych <= 'd') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'e') goto yy624;
			if (yych <= 'z') goto yy54;
		}
	}
yy442:
#line 280 "tokenizer.re"
	{ KW(ENUM) }
#line 3577 "tokenizer.cpp"
yy443:
	yych = *++cur;
	if (yych == 'V') goto yy625;
	if (yych == 'v') goto yy625;
	goto yy55;
yy444:
	yych = *++cur;
	if (yych == 'S') goto yy626;
	if (yych == 's') goto yy626;
	goto yy55;
yy445:
	yych = *++cur;
	if (yych == 'R') goto yy627;
	if (yych == 'r') goto yy627;
	goto yy55;
yy446:
	yych = *++cur;
	if (yych == 'T') goto yy629;
	if (yych == 't') goto yy629;
	goto yy55;
yy447:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 286 "tokenizer.re"
	{ KW(EXIT) }
#line 3606 "tokenizer.cpp"
yy449:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'N') goto yy631;
		if (yych <= 'Q') goto yy55;
		goto yy632;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy631;
		} else {
			if (yych == 'r') goto yy632;
			goto yy55;
		}
	}
yy450:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 289 "tokenizer.re"
	{ KW(FILE) }
#line 3630 "tokenizer.cpp"
yy452:
	yych = *++cur;
	if (yych == 'L') goto yy633;
	if (yych == 'l') goto yy633;
	goto yy55;
yy453:
	yych = *++cur;
	if (yych == 'H') goto yy635;
	if (yych == 'h') goto yy635;
	goto yy55;
yy454:
	yych = *++cur;
	if (yych == 'L') goto yy637;
	if (yych == 'l') goto yy637;
	goto yy55;
yy455:
	yych = *++cur;
	if (yych == 'A') goto yy638;
	if (yych == 'a') goto yy638;
	goto yy55;
yy456:
	yych = *++cur;
	if (yych == 'T') goto yy639;
	if (yych == 't') goto yy639;
	goto yy55;
yy457:
	yych = *++cur;
	if (yych == 'R') goto yy640;
	if (yych == 'r') goto yy640;
	goto yy55;
yy458:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 309 "tokenizer.re"
	{ KW(GOTO) }
#line 3669 "tokenizer.cpp"
yy460:
	yych = *++cur;
	if (yych == 'I') goto yy641;
	if (yych == 'i') goto yy641;
	goto yy55;
yy461:
	yych = *++cur;
	if (yych == 'R') goto yy642;
	if (yych == 'r') goto yy642;
	goto yy55;
yy462:
	yych = *++cur;
	if (yych == 'R') goto yy643;
	if (yych == 'r') goto yy643;
	goto yy55;
yy463:
	yych = *++cur;
	if (yych == 'U') goto yy644;
	if (yych == 'u') goto yy644;
	goto yy79;
yy464:
	yych = *++cur;
	if (yych == 'U') goto yy645;
	if (yych == 'u') goto yy645;
	goto yy55;
yy465:
	yych = *++cur;
	if (yych == 'T') goto yy646;
	if (yych == 't') goto yy646;
	goto yy55;
yy466:
	yych = *++cur;
	if (yych == 'I') goto yy648;
	if (yych == 'i') goto yy648;
	goto yy55;
yy467:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych <= 'M') {
			if (yych == 'G') goto yy649;
			goto yy55;
		} else {
			if (yych <= 'N') goto yy650;
			if (yych <= 'Q') goto yy55;
			goto yy651;
		}
	} else {
		if (yych <= 'm') {
			if (yych == 'g') goto yy649;
			goto yy55;
		} else {
			if (yych <= 'n') goto yy650;
			if (yych == 'r') goto yy651;
			goto yy55;
		}
	}
yy468:
	yych = *++cur;
	if (yych == 'I') goto yy652;
	if (yych == 'i') goto yy652;
	goto yy55;
yy469:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 324 "tokenizer.re"
	{ KW(KIND) }
#line 3739 "tokenizer.cpp"
yy471:
	yych = *++cur;
	if (yych == 'L') goto yy653;
	if (yych == 'l') goto yy653;
	goto yy55;
yy472:
	yych = *++cur;
	if (yych == 'C') goto yy655;
	if (yych == 'c') goto yy655;
	goto yy55;
yy473:
	yych = *++cur;
	if (yych == 'L') goto yy656;
	if (yych == 'l') goto yy656;
	goto yy55;
yy474:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 330 "tokenizer.re"
	{ KW(MOLD) }
#line 3763 "tokenizer.cpp"
yy476:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'L') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy477;
			if (yych <= 'K') goto yy54;
			goto yy657;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'l') goto yy657;
			if (yych <= 'z') goto yy54;
		}
	}
yy477:
#line 331 "tokenizer.re"
	{ KW(NAME) }
#line 3789 "tokenizer.cpp"
yy478:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 337 "tokenizer.re"
	{ KW(NONE) }
#line 3798 "tokenizer.cpp"
yy480:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'O') {
		if (yych <= '\'') {
			if (yych == '"') goto yy82;
			if (yych <= '&') goto yy55;
			goto yy97;
		} else {
			if (yych == 'I') goto yy658;
			if (yych <= 'N') goto yy55;
			goto yy659;
		}
	} else {
		if (yych <= 'i') {
			if (yych == 'R') goto yy660;
			if (yych <= 'h') goto yy55;
			goto yy658;
		} else {
			if (yych <= 'o') {
				if (yych <= 'n') goto yy55;
				goto yy659;
			} else {
				if (yych == 'r') goto yy660;
				goto yy55;
			}
		}
	}
yy481:
	yych = *++cur;
	if (yych == 'S') goto yy661;
	if (yych == 's') goto yy661;
	goto yy55;
yy482:
	yych = *++cur;
	if (yych == 'I') goto yy662;
	if (yych == 'i') goto yy662;
	goto yy55;
yy483:
	++cur;
#line 488 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3841 "tokenizer.cpp"
yy485:
	++cur;
#line 489 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3846 "tokenizer.cpp"
yy487:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 339 "tokenizer.re"
	{ KW(ONLY) }
#line 3855 "tokenizer.cpp"
yy489:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 340 "tokenizer.re"
	{ KW(OPEN) }
#line 3864 "tokenizer.cpp"
yy491:
	yych = *++cur;
	if (yych == 'A') goto yy663;
	if (yych == 'a') goto yy663;
	goto yy55;
yy492:
	yych = *++cur;
	if (yych == 'O') goto yy664;
	if (yych == 'o') goto yy664;
	goto yy55;
yy493:
	yych = *++cur;
	if (yych == 'M') goto yy665;
	if (yych == 'm') goto yy665;
	goto yy55;
yy494:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 345 "tokenizer.re"
	{ KW(PASS) }
#line 3888 "tokenizer.cpp"
yy496:
	yych = *++cur;
	if (yych == 'T') goto yy666;
	if (yych == 't') goto yy666;
	goto yy55;
yy497:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 347 "tokenizer.re"
	{ KW(POST) }
#line 3902 "tokenizer.cpp"
yy499:
	yych = *++cur;
	if (yych == 'I') goto yy667;
	if (yych == 'i') goto yy667;
	goto yy55;
yy500:
	yych = *++cur;
	if (yych == 'T') goto yy668;
	if (yych == 't') goto yy668;
	goto yy55;
yy501:
	yych = *++cur;
	if (yych == 'A') goto yy670;
	if (yych == 'a') goto yy670;
	goto yy55;
yy502:
	yych = *++cur;
	if (yych == 'E') goto yy671;
	if (yych == 'e') goto yy671;
	goto yy55;
yy503:
	yych = *++cur;
	if (yych == 'R') goto yy672;
	if (yych == 'r') goto yy672;
	goto yy55;
yy504:
	yych = *++cur;
	if (yych == 'E') goto yy673;
	if (yych == 'e') goto yy673;
	goto yy55;
yy505:
	yych = *++cur;
	if (yych == 'I') goto yy674;
	if (yych == 'i') goto yy674;
	goto yy55;
yy506:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 355 "tokenizer.re"
	{ KW(PURE) }
#line 3946 "tokenizer.cpp"
yy508:
	yych = *++cur;
	if (yych == 'T') goto yy675;
	if (yych == 't') goto yy675;
	goto yy55;
yy509:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 357 "tokenizer.re"
	{ KW(RANK) }
#line 3960 "tokenizer.cpp"
yy511:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 358 "tokenizer.re"
	{ KW(READ) }
#line 3969 "tokenizer.cpp"
yy513:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 359 "tokenizer.re"
	{KW(REAL) }
#line 3978 "tokenizer.cpp"
yy515:
	yych = *++cur;
	if (yych == 'R') goto yy677;
	if (yych == 'r') goto yy677;
	goto yy55;
yy516:
	yych = *++cur;
	if (yych == 'C') goto yy678;
	if (yych == 'c') goto yy678;
	goto yy55;
yy517:
	yych = *++cur;
	if (yych == 'L') goto yy679;
	if (yych == 'l') goto yy679;
	goto yy55;
yy518:
	yych = *++cur;
	if (yych == 'R') goto yy680;
	if (yych == 'r') goto yy680;
	goto yy55;
yy519:
	yych = *++cur;
	if (yych == 'N') goto yy681;
	if (yych == 'n') goto yy681;
	goto yy55;
yy520:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 365 "tokenizer.re"
	{ KW(SAVE) }
#line 4012 "tokenizer.cpp"
yy522:
	yych = *++cur;
	if (yych == 'C') goto yy682;
	if (yych == 'c') goto yy682;
	goto yy55;
yy523:
	yych = *++cur;
	if (yych == 'E') goto yy683;
	if (yych == 'e') goto yy683;
	goto yy55;
yy524:
	yych = *++cur;
	if (yych == 'E') goto yy684;
	if (yych == 'e') goto yy684;
	goto yy55;
yy525:
	yych = *++cur;
	if (yych == 'C') goto yy685;
	if (yych == 'c') goto yy685;
	goto yy55;
yy526:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 373 "tokenizer.re"
	{ KW(STAT) }
#line 4041 "tokenizer.cpp"
yy528:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 374 "tokenizer.re"
	{ KW(STOP) }
#line 4050 "tokenizer.cpp"
yy530:
	yych = *++cur;
	if (yych == 'O') goto yy686;
	if (yych == 'o') goto yy686;
	goto yy55;
yy531:
	yych = *++cur;
	if (yych == 'O') goto yy687;
	if (yych == 'o') goto yy687;
	goto yy55;
yy532:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 377 "tokenizer.re"
	{ KW(SYNC) }
#line 4069 "tokenizer.cpp"
yy534:
	yych = *++cur;
	if (yych == 'E') goto yy688;
	if (yych == 'e') goto yy688;
	goto yy55;
yy535:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy689;
#line 379 "tokenizer.re"
	{ KW(TEAM) }
#line 4083 "tokenizer.cpp"
yy537:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 381 "tokenizer.re"
	{ KW(THEN) }
#line 4092 "tokenizer.cpp"
yy539:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 383 "tokenizer.re"
	{ KW(TYPE) }
#line 4101 "tokenizer.cpp"
yy541:
	yych = *++cur;
	if (yych == 'R') goto yy690;
	if (yych == 'r') goto yy690;
	goto yy55;
yy542:
	yych = *++cur;
	if (yych == 'E') goto yy691;
	if (yych == 'e') goto yy691;
	goto yy55;
yy543:
	yych = *++cur;
	if (yych == 'T') goto yy693;
	if (yych == 't') goto yy693;
	goto yy55;
yy544:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 388 "tokenizer.re"
	{ KW(WAIT) }
#line 4125 "tokenizer.cpp"
yy546:
	yych = *++cur;
	if (yych == 'E') goto yy694;
	if (yych == 'e') goto yy694;
	goto yy55;
yy547:
	yych = *++cur;
	if (yych == 'E') goto yy696;
	if (yych == 'e') goto yy696;
	goto yy55;
yy548:
	yych = *++cur;
	if (yych == 'E') goto yy698;
	if (yych == 'e') goto yy698;
	goto yy55;
yy549:
	++cur;
#line 490 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4145 "tokenizer.cpp"
yy551:
	++cur;
#line 491 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4150 "tokenizer.cpp"
yy553:
	++cur;
#line 436 "tokenizer.re"
	{ RET(TK_AND) }
#line 4155 "tokenizer.cpp"
yy555:
	++cur;
#line 438 "tokenizer.re"
	{ RET(TK_EQV) }
#line 4160 "tokenizer.cpp"
yy557:
	yych = *++cur;
	if (yych == 'E') goto yy700;
	if (yych == 'e') goto yy700;
	goto yy111;
yy558:
	yych = *++cur;
	if (yych == '.') goto yy701;
	goto yy111;
yy559:
	++cur;
#line 435 "tokenizer.re"
	{ RET(TK_NOT) }
#line 4174 "tokenizer.cpp"
yy561:
	yych = *++cur;
	if (yych == '.') goto yy703;
	goto yy111;
yy562:
	yych = *++cur;
	if (yych == 'A') goto yy705;
	if (yych == 'a') goto yy705;
	goto yy55;
yy563:
	yych = *++cur;
	if (yych == 'A') goto yy706;
	if (yych == 'a') goto yy706;
	goto yy55;
yy564:
	yych = *++cur;
	if (yych == 'N') goto yy707;
	if (yych == 'n') goto yy707;
	goto yy55;
yy565:
	yych = *++cur;
	if (yych == 'I') goto yy708;
	if (yych == 'i') goto yy708;
	goto yy55;
yy566:
	yych = *++cur;
	if (yych == 'H') goto yy709;
	if (yych == 'h') goto yy709;
	goto yy55;
yy567:
	yych = *++cur;
	if (yych == 'P') goto yy710;
	if (yych == 'p') goto yy710;
	goto yy55;
yy568:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 192 "tokenizer.re"
	{ KW(BLOCK) }
#line 4217 "tokenizer.cpp"
yy570:
	yych = *++cur;
	if (yych == 'C') goto yy711;
	if (yych == 'c') goto yy711;
	goto yy55;
yy571:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 196 "tokenizer.re"
	{ KW(CLASS) }
#line 4231 "tokenizer.cpp"
yy573:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 197 "tokenizer.re"
	{ KW(CLOSE) }
#line 4240 "tokenizer.cpp"
yy575:
	yych = *++cur;
	if (yych == 'E') goto yy712;
	if (yych == 'e') goto yy712;
	goto yy55;
yy576:
	yych = *++cur;
	if (yych == 'N') goto yy713;
	if (yych == 'n') goto yy713;
	goto yy55;
yy577:
	yych = *++cur;
	if (yych == 'E') goto yy715;
	if (yych == 'e') goto yy715;
	goto yy55;
yy578:
	yych = *++cur;
	if (yych == 'R') goto yy716;
	if (yych == 'r') goto yy716;
	goto yy55;
yy579:
	yych = *++cur;
	if (yych == 'I') goto yy717;
	if (yych == 'i') goto yy717;
	goto yy55;
yy580:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'G') goto yy718;
		if (yych <= 'M') goto yy55;
		goto yy719;
	} else {
		if (yych <= 'g') {
			if (yych <= 'f') goto yy55;
			goto yy718;
		} else {
			if (yych == 'n') goto yy719;
			goto yy55;
		}
	}
yy581:
	yych = *++cur;
	if (yych == 'C') goto yy720;
	if (yych == 'c') goto yy720;
	goto yy55;
yy582:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 206 "tokenizer.re"
	{ KW(CYCLE) }
#line 4294 "tokenizer.cpp"
yy584:
	yych = *++cur;
	if (yych == 'O') goto yy721;
	if (yych == 'o') goto yy721;
	goto yy55;
yy585:
	yych = *++cur;
	if (yych == 'L') goto yy722;
	if (yych == 'l') goto yy722;
	goto yy55;
yy586:
	yych = *++cur;
	if (yych == 'R') goto yy723;
	if (yych == 'r') goto yy723;
	goto yy55;
yy587:
	yych = *++cur;
	if (yych == 'S') goto yy724;
	if (yych == 's') goto yy724;
	goto yy55;
yy588:
	yych = *++cur;
	if (yych == 'E') goto yy725;
	if (yych == 'e') goto yy725;
	goto yy55;
yy589:
	yych = *++cur;
	if (yych == 'L') goto yy727;
	if (yych == 'l') goto yy727;
	goto yy55;
yy590:
	yych = *++cur;
	if (yych == 'N') goto yy728;
	if (yych == 'n') goto yy728;
	goto yy55;
yy591:
	yych = *++cur;
	if (yych == 'F') goto yy729;
	if (yych == 'f') goto yy729;
	goto yy55;
yy592:
	yych = *++cur;
	if (yych == 'H') goto yy731;
	if (yych == 'h') goto yy731;
	goto yy55;
yy593:
	yych = *++cur;
	if (yych == 'S') goto yy732;
	if (yych == 's') goto yy732;
	goto yy79;
yy594:
	yych = *++cur;
	if (yych == 'L') goto yy733;
	if (yych == 'l') goto yy733;
	goto yy79;
yy595:
	yych = *++cur;
	if (yych == 'R') goto yy734;
	if (yych == 'r') goto yy734;
	goto yy79;
yy596:
	yych = *++cur;
	if (yych == 'O') goto yy735;
	if (yych == 'o') goto yy735;
	goto yy79;
yy597:
	yych = *++cur;
	if (yych == 'N') goto yy737;
	if (yych == 'n') goto yy737;
	goto yy79;
yy598:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'O') goto yy738;
		if (yych <= 'T') goto yy79;
		goto yy739;
	} else {
		if (yych <= 'o') {
			if (yych <= 'n') goto yy79;
			goto yy738;
		} else {
			if (yych == 'u') goto yy739;
			goto yy79;
		}
	}
yy599:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'F') goto yy740;
		if (yych <= 'M') goto yy79;
		goto yy742;
	} else {
		if (yych <= 'f') {
			if (yych <= 'e') goto yy79;
			goto yy740;
		} else {
			if (yych == 'n') goto yy742;
			goto yy79;
		}
	}
yy600:
	yych = *++cur;
	if (yych == 'O') goto yy743;
	if (yych == 'o') goto yy743;
	goto yy79;
yy601:
	yych = *++cur;
	if (yych == 'R') goto yy744;
	if (yych == 'r') goto yy744;
	goto yy79;
yy602:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'E') goto yy745;
		if (yych <= 'T') goto yy79;
		goto yy746;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy79;
			goto yy745;
		} else {
			if (yych == 'u') goto yy746;
			goto yy79;
		}
	}
yy603:
	yych = *++cur;
	if (yych == 'Y') goto yy747;
	if (yych == 'y') goto yy747;
	goto yy79;
yy604:
	yych = *++cur;
	if (yych == 'H') goto yy748;
	if (yych == 'h') goto yy748;
	goto yy79;
yy605:
	yych = *++cur;
	if (yych == 'S') goto yy749;
	if (yych == 's') goto yy749;
	goto yy55;
yy606:
	yych = *++cur;
	if (yych == 'O') goto yy750;
	if (yych == 'o') goto yy750;
	goto yy55;
yy607:
	yych = *++cur;
	if (yych == 'I') goto yy751;
	if (yych == 'i') goto yy751;
	goto yy55;
yy608:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 274 "tokenizer.re"
	{ KW(ENDDO) }
#line 4453 "tokenizer.cpp"
yy610:
	yych = *++cur;
	if (yych == 'U') goto yy752;
	if (yych == 'u') goto yy752;
	goto yy55;
yy611:
	yych = *++cur;
	if (yych == 'R') goto yy753;
	if (yych == 'r') goto yy753;
	goto yy55;
yy612:
	yych = *++cur;
	if (yych == 'N') goto yy754;
	if (yych == 'n') goto yy754;
	goto yy55;
yy613:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 265 "tokenizer.re"
	{ KW(ENDIF) }
#line 4477 "tokenizer.cpp"
yy615:
	yych = *++cur;
	if (yych == 'T') goto yy755;
	if (yych == 't') goto yy755;
	goto yy55;
yy616:
	yych = *++cur;
	if (yych == 'D') goto yy756;
	if (yych == 'd') goto yy756;
	goto yy55;
yy617:
	yych = *++cur;
	if (yych == 'O') goto yy757;
	if (yych == 'o') goto yy757;
	goto yy55;
yy618:
	yych = *++cur;
	if (yych == 'L') goto yy758;
	if (yych == 'l') goto yy758;
	goto yy55;
yy619:
	yych = *++cur;
	if (yych == 'B') goto yy759;
	if (yych == 'b') goto yy759;
	goto yy55;
yy620:
	yych = *++cur;
	if (yych == 'P') goto yy760;
	if (yych == 'p') goto yy760;
	goto yy55;
yy621:
	yych = *++cur;
	if (yych == 'E') goto yy761;
	if (yych == 'e') goto yy761;
	goto yy55;
yy622:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 279 "tokenizer.re"
	{ KW(ENTRY) }
#line 4521 "tokenizer.cpp"
yy624:
	yych = *++cur;
	if (yych == 'R') goto yy762;
	if (yych == 'r') goto yy762;
	goto yy55;
yy625:
	yych = *++cur;
	if (yych == 'A') goto yy763;
	if (yych == 'a') goto yy763;
	goto yy55;
yy626:
	yych = *++cur;
	if (yych == 'G') goto yy764;
	if (yych == 'g') goto yy764;
	goto yy55;
yy627:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 284 "tokenizer.re"
	{ KW(ERROR) }
#line 4545 "tokenizer.cpp"
yy629:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 285 "tokenizer.re"
	{ KW(EVENT) }
#line 4554 "tokenizer.cpp"
yy631:
	yych = *++cur;
	if (yych == 'D') goto yy766;
	if (yych == 'd') goto yy766;
	goto yy55;
yy632:
	yych = *++cur;
	if (yych == 'N') goto yy767;
	if (yych == 'n') goto yy767;
	goto yy55;
yy633:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 290 "tokenizer.re"
	{ KW(FINAL) }
#line 4573 "tokenizer.cpp"
yy635:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 291 "tokenizer.re"
	{ KW(FLUSH) }
#line 4582 "tokenizer.cpp"
yy637:
	yych = *++cur;
	if (yych == 'L') goto yy768;
	if (yych == 'l') goto yy768;
	goto yy55;
yy638:
	yych = *++cur;
	if (yych == 'T') goto yy770;
	if (yych == 't') goto yy770;
	goto yy55;
yy639:
	yych = *++cur;
	if (yych == 'I') goto yy772;
	if (yych == 'i') goto yy772;
	goto yy55;
yy640:
	yych = *++cur;
	if (yych == 'I') goto yy773;
	if (yych == 'i') goto yy773;
	goto yy55;
yy641:
	yych = *++cur;
	if (yych == 'C') goto yy774;
	if (yych == 'c') goto yy774;
	goto yy55;
yy642:
	yych = *++cur;
	if (yych == 'T') goto yy775;
	if (yych == 't') goto yy775;
	goto yy55;
yy643:
	yych = *++cur;
	if (yych == 'E') goto yy777;
	if (yych == 'e') goto yy777;
	goto yy55;
yy644:
	yych = *++cur;
	if (yych == 'T') goto yy779;
	if (yych == 't') goto yy779;
	goto yy79;
yy645:
	yych = *++cur;
	if (yych == 'D') goto yy781;
	if (yych == 'd') goto yy781;
	goto yy55;
yy646:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 316 "tokenizer.re"
	{ KW(INOUT) }
#line 4636 "tokenizer.cpp"
yy648:
	yych = *++cur;
	if (yych == 'R') goto yy782;
	if (yych == 'r') goto yy782;
	goto yy55;
yy649:
	yych = *++cur;
	if (yych == 'E') goto yy783;
	if (yych == 'e') goto yy783;
	goto yy55;
yy650:
	yych = *++cur;
	if (yych == 'T') goto yy784;
	if (yych == 't') goto yy784;
	goto yy55;
yy651:
	yych = *++cur;
	if (yych == 'F') goto yy786;
	if (yych == 'f') goto yy786;
	goto yy55;
yy652:
	yych = *++cur;
	if (yych == 'N') goto yy787;
	if (yych == 'n') goto yy787;
	goto yy55;
yy653:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy788;
#line 326 "tokenizer.re"
	{ KW(LOCAL) }
#line 4670 "tokenizer.cpp"
yy655:
	yych = *++cur;
	if (yych == 'A') goto yy789;
	if (yych == 'a') goto yy789;
	goto yy55;
yy656:
	yych = *++cur;
	if (yych == 'E') goto yy790;
	if (yych == 'e') goto yy790;
	goto yy55;
yy657:
	yych = *++cur;
	if (yych == 'I') goto yy792;
	if (yych == 'i') goto yy792;
	goto yy55;
yy658:
	yych = *++cur;
	if (yych == 'N') goto yy793;
	if (yych == 'n') goto yy793;
	goto yy55;
yy659:
	yych = *++cur;
	if (yych == 'V') goto yy794;
	if (yych == 'v') goto yy794;
	goto yy55;
yy660:
	yych = *++cur;
	if (yych == 'E') goto yy795;
	if (yych == 'e') goto yy795;
	goto yy55;
yy661:
	yych = *++cur;
	if (yych == 'S') goto yy796;
	if (yych == 's') goto yy796;
	goto yy55;
yy662:
	yych = *++cur;
	if (yych == 'F') goto yy798;
	if (yych == 'f') goto yy798;
	goto yy55;
yy663:
	yych = *++cur;
	if (yych == 'T') goto yy799;
	if (yych == 't') goto yy799;
	goto yy55;
yy664:
	yych = *++cur;
	if (yych == 'N') goto yy800;
	if (yych == 'n') goto yy800;
	goto yy55;
yy665:
	yych = *++cur;
	if (yych == 'E') goto yy801;
	if (yych == 'e') goto yy801;
	goto yy55;
yy666:
	yych = *++cur;
	if (yych == 'E') goto yy802;
	if (yych == 'e') goto yy802;
	goto yy55;
yy667:
	yych = *++cur;
	if (yych == 'S') goto yy803;
	if (yych == 's') goto yy803;
	goto yy55;
yy668:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 349 "tokenizer.re"
	{ KW(PRINT) }
#line 4744 "tokenizer.cpp"
yy670:
	yych = *++cur;
	if (yych == 'T') goto yy804;
	if (yych == 't') goto yy804;
	goto yy55;
yy671:
	yych = *++cur;
	if (yych == 'D') goto yy805;
	if (yych == 'd') goto yy805;
	goto yy55;
yy672:
	yych = *++cur;
	if (yych == 'A') goto yy806;
	if (yych == 'a') goto yy806;
	goto yy55;
yy673:
	yych = *++cur;
	if (yych == 'C') goto yy807;
	if (yych == 'c') goto yy807;
	goto yy55;
yy674:
	yych = *++cur;
	if (yych == 'C') goto yy808;
	if (yych == 'c') goto yy808;
	goto yy55;
yy675:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 356 "tokenizer.re"
	{ KW(QUIET) }
#line 4778 "tokenizer.cpp"
yy677:
	yych = *++cur;
	if (yych == 'S') goto yy810;
	if (yych == 's') goto yy810;
	goto yy55;
yy678:
	yych = *++cur;
	if (yych == 'E') goto yy811;
	if (yych == 'e') goto yy811;
	goto yy55;
yy679:
	yych = *++cur;
	if (yych == 'T') goto yy813;
	if (yych == 't') goto yy813;
	goto yy55;
yy680:
	yych = *++cur;
	if (yych == 'N') goto yy815;
	if (yych == 'n') goto yy815;
	goto yy55;
yy681:
	yych = *++cur;
	if (yych == 'D') goto yy817;
	if (yych == 'd') goto yy817;
	goto yy55;
yy682:
	yych = *++cur;
	if (yych == 'T') goto yy819;
	if (yych == 't') goto yy819;
	goto yy55;
yy683:
	yych = *++cur;
	if (yych == 'N') goto yy821;
	if (yych == 'n') goto yy821;
	goto yy55;
yy684:
	yych = *++cur;
	if (yych == 'D') goto yy822;
	if (yych == 'd') goto yy822;
	goto yy55;
yy685:
	yych = *++cur;
	if (yych == 'E') goto yy824;
	if (yych == 'e') goto yy824;
	goto yy55;
yy686:
	yych = *++cur;
	if (yych == 'D') goto yy826;
	if (yych == 'd') goto yy826;
	goto yy55;
yy687:
	yych = *++cur;
	if (yych == 'U') goto yy827;
	if (yych == 'u') goto yy827;
	goto yy55;
yy688:
	yych = *++cur;
	if (yych == 'T') goto yy828;
	if (yych == 't') goto yy828;
	goto yy55;
yy689:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= '\'') {
		if (yych == '"') goto yy82;
		if (yych <= '&') goto yy55;
		goto yy97;
	} else {
		if (yych <= 'N') {
			if (yych <= 'M') goto yy55;
			goto yy830;
		} else {
			if (yych == 'n') goto yy830;
			goto yy55;
		}
	}
yy690:
	yych = *++cur;
	if (yych == 'M') goto yy831;
	if (yych == 'm') goto yy831;
	goto yy55;
yy691:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 386 "tokenizer.re"
	{ KW(VALUE) }
#line 4868 "tokenizer.cpp"
yy693:
	yych = *++cur;
	if (yych == 'I') goto yy832;
	if (yych == 'i') goto yy832;
	goto yy55;
yy694:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 389 "tokenizer.re"
	{ KW(WHERE) }
#line 4882 "tokenizer.cpp"
yy696:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 390 "tokenizer.re"
	{ KW(WHILE) }
#line 4891 "tokenizer.cpp"
yy698:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 391 "tokenizer.re"
	{ KW(WRITE) }
#line 4900 "tokenizer.cpp"
yy700:
	yych = *++cur;
	if (yych == '.') goto yy833;
	goto yy111;
yy701:
	++cur;
#line 439 "tokenizer.re"
	{ RET(TK_NEQV) }
#line 4909 "tokenizer.cpp"
yy703:
	yyaccept = 10;
	yych = *(mar = ++cur);
	if (yych == '_') goto yy835;
yy704:
#line 443 "tokenizer.re"
	{ RET(TK_TRUE) }
#line 4917 "tokenizer.cpp"
yy705:
	yych = *++cur;
	if (yych == 'C') goto yy836;
	if (yych == 'c') goto yy836;
	goto yy55;
yy706:
	yych = *++cur;
	if (yych == 'T') goto yy837;
	if (yych == 't') goto yy837;
	goto yy55;
yy707:
	yych = *++cur;
	if (yych == 'M') goto yy838;
	if (yych == 'm') goto yy838;
	goto yy55;
yy708:
	yych = *++cur;
	if (yych == 'A') goto yy839;
	if (yych == 'a') goto yy839;
	goto yy55;
yy709:
	yych = *++cur;
	if (yych == 'R') goto yy840;
	if (yych == 'r') goto yy840;
	goto yy55;
yy710:
	yych = *++cur;
	if (yych == 'A') goto yy841;
	if (yych == 'a') goto yy841;
	goto yy55;
yy711:
	yych = *++cur;
	if (yych == 'T') goto yy842;
	if (yych == 't') goto yy842;
	goto yy55;
yy712:
	yych = *++cur;
	if (yych == 'N') goto yy843;
	if (yych == 'n') goto yy843;
	goto yy55;
yy713:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 199 "tokenizer.re"
	{ KW(COMMON) }
#line 4966 "tokenizer.cpp"
yy715:
	yych = *++cur;
	if (yych == 'X') goto yy844;
	if (yych == 'x') goto yy844;
	goto yy55;
yy716:
	yych = *++cur;
	if (yych == 'R') goto yy846;
	if (yych == 'r') goto yy846;
	goto yy55;
yy717:
	yych = *++cur;
	if (yych == 'N') goto yy847;
	if (yych == 'n') goto yy847;
	goto yy55;
yy718:
	yych = *++cur;
	if (yych == 'U') goto yy848;
	if (yych == 'u') goto yy848;
	goto yy55;
yy719:
	yych = *++cur;
	if (yych == 'U') goto yy849;
	if (yych == 'u') goto yy849;
	goto yy55;
yy720:
	yych = *++cur;
	if (yych == 'A') goto yy850;
	if (yych == 'a') goto yy850;
	goto yy55;
yy721:
	yych = *++cur;
	if (yych == 'C') goto yy851;
	if (yych == 'c') goto yy851;
	goto yy55;
yy722:
	yych = *++cur;
	if (yych == 'T') goto yy852;
	if (yych == 't') goto yy852;
	goto yy55;
yy723:
	yych = *++cur;
	if (yych == 'E') goto yy854;
	if (yych == 'e') goto yy854;
	goto yy55;
yy724:
	yych = *++cur;
	if (yych == 'I') goto yy855;
	if (yych == 'i') goto yy855;
	goto yy55;
yy725:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'P') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy726;
			if (yych <= 'O') goto yy54;
			goto yy856;
		}
	} else {
		if (yych <= 'o') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'p') goto yy856;
			if (yych <= 'z') goto yy54;
		}
	}
yy726:
#line 214 "tokenizer.re"
	{ KW(DOUBLE) }
#line 5042 "tokenizer.cpp"
yy727:
	yych = *++cur;
	if (yych == 'E') goto yy857;
	if (yych == 'e') goto yy857;
	goto yy55;
yy728:
	yych = *++cur;
	if (yych == 'T') goto yy859;
	if (yych == 't') goto yy859;
	goto yy55;
yy729:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 218 "tokenizer.re"
	{ KW(ELSEIF) }
#line 5061 "tokenizer.cpp"
yy731:
	yych = *++cur;
	if (yych == 'E') goto yy860;
	if (yych == 'e') goto yy860;
	goto yy55;
yy732:
	yych = *++cur;
	if (yych == 'S') goto yy861;
	if (yych == 's') goto yy861;
	goto yy79;
yy733:
	yych = *++cur;
	if (yych == 'O') goto yy862;
	if (yych == 'o') goto yy862;
	goto yy79;
yy734:
	yych = *++cur;
	if (yych == 'I') goto yy863;
	if (yych == 'i') goto yy863;
	goto yy79;
yy735:
	++cur;
#line 273 "tokenizer.re"
	{ KW(END_DO) }
#line 5086 "tokenizer.cpp"
yy737:
	yych = *++cur;
	if (yych == 'U') goto yy864;
	if (yych == 'u') goto yy864;
	goto yy79;
yy738:
	yych = *++cur;
	if (yych == 'R') goto yy865;
	if (yych == 'r') goto yy865;
	goto yy79;
yy739:
	yych = *++cur;
	if (yych == 'N') goto yy866;
	if (yych == 'n') goto yy866;
	goto yy79;
yy740:
	++cur;
#line 264 "tokenizer.re"
	{ KW(END_IF) }
#line 5106 "tokenizer.cpp"
yy742:
	yych = *++cur;
	if (yych == 'T') goto yy867;
	if (yych == 't') goto yy867;
	goto yy79;
yy743:
	yych = *++cur;
	if (yych == 'D') goto yy868;
	if (yych == 'd') goto yy868;
	goto yy79;
yy744:
	yych = *++cur;
	if (yych == 'O') goto yy869;
	if (yych == 'o') goto yy869;
	goto yy79;
yy745:
	yych = *++cur;
	if (yych == 'L') goto yy870;
	if (yych == 'l') goto yy870;
	goto yy79;
yy746:
	yych = *++cur;
	if (yych == 'B') goto yy871;
	if (yych == 'b') goto yy871;
	goto yy79;
yy747:
	yych = *++cur;
	if (yych == 'P') goto yy872;
	if (yych == 'p') goto yy872;
	goto yy79;
yy748:
	yych = *++cur;
	if (yych == 'E') goto yy873;
	if (yych == 'e') goto yy873;
	goto yy79;
yy749:
	yych = *++cur;
	if (yych == 'O') goto yy874;
	if (yych == 'o') goto yy874;
	goto yy55;
yy750:
	yych = *++cur;
	if (yych == 'C') goto yy875;
	if (yych == 'c') goto yy875;
	goto yy55;
yy751:
	yych = *++cur;
	if (yych == 'T') goto yy876;
	if (yych == 't') goto yy876;
	goto yy55;
yy752:
	yych = *++cur;
	if (yych == 'M') goto yy877;
	if (yych == 'm') goto yy877;
	goto yy55;
yy753:
	yych = *++cur;
	if (yych == 'A') goto yy879;
	if (yych == 'a') goto yy879;
	goto yy55;
yy754:
	yych = *++cur;
	if (yych == 'C') goto yy880;
	if (yych == 'c') goto yy880;
	goto yy55;
yy755:
	yych = *++cur;
	if (yych == 'E') goto yy881;
	if (yych == 'e') goto yy881;
	goto yy55;
yy756:
	yych = *++cur;
	if (yych == 'U') goto yy882;
	if (yych == 'u') goto yy882;
	goto yy55;
yy757:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy883;
		if (yych <= 'F') goto yy55;
		goto yy884;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy883;
		} else {
			if (yych == 'g') goto yy884;
			goto yy55;
		}
	}
yy758:
	yych = *++cur;
	if (yych == 'E') goto yy885;
	if (yych == 'e') goto yy885;
	goto yy55;
yy759:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy886;
		if (yych <= 'Q') goto yy55;
		goto yy887;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy886;
		} else {
			if (yych == 'r') goto yy887;
			goto yy55;
		}
	}
yy760:
	yych = *++cur;
	if (yych == 'E') goto yy888;
	if (yych == 'e') goto yy888;
	goto yy55;
yy761:
	yych = *++cur;
	if (yych == 'R') goto yy890;
	if (yych == 'r') goto yy890;
	goto yy55;
yy762:
	yych = *++cur;
	if (yych == 'A') goto yy891;
	if (yych == 'a') goto yy891;
	goto yy55;
yy763:
	yych = *++cur;
	if (yych == 'L') goto yy892;
	if (yych == 'l') goto yy892;
	goto yy55;
yy764:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 283 "tokenizer.re"
	{ KW(ERRMSG) }
#line 5245 "tokenizer.cpp"
yy766:
	yych = *++cur;
	if (yych == 'S') goto yy893;
	if (yych == 's') goto yy893;
	goto yy55;
yy767:
	yych = *++cur;
	if (yych == 'A') goto yy895;
	if (yych == 'a') goto yy895;
	goto yy55;
yy768:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 292 "tokenizer.re"
	{ KW(FORALL) }
#line 5264 "tokenizer.cpp"
yy770:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy771;
			if (yych <= 'S') goto yy54;
			goto yy896;
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 't') goto yy896;
			if (yych <= 'z') goto yy54;
		}
	}
yy771:
#line 293 "tokenizer.re"
	{
                if (last_token == yytokentype::TK_LABEL) {
                    unsigned char *start;
                    lex_format(cur, loc, start);
                    yylval.string.p = (char*) start;
                    yylval.string.n = cur-start-1;
                    RET(TK_FORMAT)
                } else {
                    token(yylval.string);
                    RET(TK_NAME)
                }
            }
#line 5301 "tokenizer.cpp"
yy772:
	yych = *++cur;
	if (yych == 'O') goto yy897;
	if (yych == 'o') goto yy897;
	goto yy55;
yy773:
	yych = *++cur;
	if (yych == 'C') goto yy898;
	if (yych == 'c') goto yy898;
	goto yy55;
yy774:
	yych = *++cur;
	if (yych == 'I') goto yy900;
	if (yych == 'i') goto yy900;
	goto yy55;
yy775:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 312 "tokenizer.re"
	{ KW(IMPORT) }
#line 5325 "tokenizer.cpp"
yy777:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 313 "tokenizer.re"
	{ KW(IMPURE) }
#line 5334 "tokenizer.cpp"
yy779:
	++cur;
#line 317 "tokenizer.re"
	{ KW(IN_OUT) }
#line 5339 "tokenizer.cpp"
yy781:
	yych = *++cur;
	if (yych == 'E') goto yy901;
	if (yych == 'e') goto yy901;
	goto yy55;
yy782:
	yych = *++cur;
	if (yych == 'E') goto yy903;
	if (yych == 'e') goto yy903;
	goto yy55;
yy783:
	yych = *++cur;
	if (yych == 'R') goto yy905;
	if (yych == 'r') goto yy905;
	goto yy55;
yy784:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 320 "tokenizer.re"
	{ KW(INTENT) }
#line 5363 "tokenizer.cpp"
yy786:
	yych = *++cur;
	if (yych == 'A') goto yy907;
	if (yych == 'a') goto yy907;
	goto yy55;
yy787:
	yych = *++cur;
	if (yych == 'S') goto yy908;
	if (yych == 's') goto yy908;
	goto yy55;
yy788:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= '\'') {
		if (yych == '"') goto yy82;
		if (yych <= '&') goto yy55;
		goto yy97;
	} else {
		if (yych <= 'I') {
			if (yych <= 'H') goto yy55;
			goto yy909;
		} else {
			if (yych == 'i') goto yy909;
			goto yy55;
		}
	}
yy789:
	yych = *++cur;
	if (yych == 'L') goto yy910;
	if (yych == 'l') goto yy910;
	goto yy55;
yy790:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 329 "tokenizer.re"
	{ KW(MODULE) }
#line 5403 "tokenizer.cpp"
yy792:
	yych = *++cur;
	if (yych == 'S') goto yy912;
	if (yych == 's') goto yy912;
	goto yy55;
yy793:
	yych = *++cur;
	if (yych == 'T') goto yy913;
	if (yych == 't') goto yy913;
	goto yy55;
yy794:
	yych = *++cur;
	if (yych == 'E') goto yy914;
	if (yych == 'e') goto yy914;
	goto yy55;
yy795:
	yych = *++cur;
	if (yych == 'C') goto yy915;
	if (yych == 'c') goto yy915;
	goto yy55;
yy796:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 333 "tokenizer.re"
	{ KW(NOPASS) }
#line 5432 "tokenizer.cpp"
yy798:
	yych = *++cur;
	if (yych == 'Y') goto yy916;
	if (yych == 'y') goto yy916;
	goto yy55;
yy799:
	yych = *++cur;
	if (yych == 'O') goto yy918;
	if (yych == 'o') goto yy918;
	goto yy55;
yy800:
	yych = *++cur;
	if (yych == 'A') goto yy919;
	if (yych == 'a') goto yy919;
	goto yy55;
yy801:
	yych = *++cur;
	if (yych == 'T') goto yy920;
	if (yych == 't') goto yy920;
	goto yy55;
yy802:
	yych = *++cur;
	if (yych == 'R') goto yy921;
	if (yych == 'r') goto yy921;
	goto yy55;
yy803:
	yych = *++cur;
	if (yych == 'I') goto yy923;
	if (yych == 'i') goto yy923;
	goto yy55;
yy804:
	yych = *++cur;
	if (yych == 'E') goto yy924;
	if (yych == 'e') goto yy924;
	goto yy55;
yy805:
	yych = *++cur;
	if (yych == 'U') goto yy926;
	if (yych == 'u') goto yy926;
	goto yy55;
yy806:
	yych = *++cur;
	if (yych == 'M') goto yy927;
	if (yych == 'm') goto yy927;
	goto yy55;
yy807:
	yych = *++cur;
	if (yych == 'T') goto yy929;
	if (yych == 't') goto yy929;
	goto yy55;
yy808:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 354 "tokenizer.re"
	{ KW(PUBLIC) }
#line 5491 "tokenizer.cpp"
yy810:
	yych = *++cur;
	if (yych == 'I') goto yy930;
	if (yych == 'i') goto yy930;
	goto yy55;
yy811:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 361 "tokenizer.re"
	{ KW(REDUCE) }
#line 5505 "tokenizer.cpp"
yy813:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 362 "tokenizer.re"
	{ KW(RESULT) }
#line 5514 "tokenizer.cpp"
yy815:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 363 "tokenizer.re"
	{ KW(RETURN) }
#line 5523 "tokenizer.cpp"
yy817:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 364 "tokenizer.re"
	{ KW(REWIND) }
#line 5532 "tokenizer.cpp"
yy819:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= 'B') {
			if (yych <= '/') goto yy820;
			if (yych <= '9') goto yy54;
			if (yych >= 'A') goto yy54;
		} else {
			if (yych <= 'Q') {
				if (yych <= 'C') goto yy931;
				goto yy54;
			} else {
				if (yych <= 'R') goto yy932;
				if (yych <= 'S') goto yy54;
				goto yy933;
			}
		}
	} else {
		if (yych <= 'q') {
			if (yych <= '`') {
				if (yych <= 'Z') goto yy54;
			} else {
				if (yych == 'c') goto yy931;
				goto yy54;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy932;
				goto yy54;
			} else {
				if (yych <= 't') goto yy933;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy820:
#line 366 "tokenizer.re"
	{ KW(SELECT) }
#line 5574 "tokenizer.cpp"
yy821:
	yych = *++cur;
	if (yych == 'C') goto yy934;
	if (yych == 'c') goto yy934;
	goto yy55;
yy822:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 371 "tokenizer.re"
	{ KW(SHARED) }
#line 5588 "tokenizer.cpp"
yy824:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 372 "tokenizer.re"
	{ KW(SOURCE) }
#line 5597 "tokenizer.cpp"
yy826:
	yych = *++cur;
	if (yych == 'U') goto yy935;
	if (yych == 'u') goto yy935;
	goto yy55;
yy827:
	yych = *++cur;
	if (yych == 'T') goto yy936;
	if (yych == 't') goto yy936;
	goto yy55;
yy828:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 378 "tokenizer.re"
	{ KW(TARGET) }
#line 5616 "tokenizer.cpp"
yy830:
	yych = *++cur;
	if (yych == 'U') goto yy937;
	if (yych == 'u') goto yy937;
	goto yy55;
yy831:
	yych = *++cur;
	if (yych == 'A') goto yy938;
	if (yych == 'a') goto yy938;
	goto yy55;
yy832:
	yych = *++cur;
	if (yych == 'L') goto yy939;
	if (yych == 'l') goto yy939;
	goto yy55;
yy833:
	yyaccept = 11;
	yych = *(mar = ++cur);
	if (yych == '_') goto yy940;
yy834:
#line 444 "tokenizer.re"
	{ RET(TK_FALSE) }
#line 5639 "tokenizer.cpp"
yy835:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy941;
		if (yych <= '@') goto yy79;
		goto yy943;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy943;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy943;
			goto yy79;
		}
	}
yy836:
	yych = *++cur;
	if (yych == 'T') goto yy945;
	if (yych == 't') goto yy945;
	goto yy55;
yy837:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy947;
		if (yych <= 'D') goto yy55;
		goto yy948;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy947;
		} else {
			if (yych == 'e') goto yy948;
			goto yy55;
		}
	}
yy838:
	yych = *++cur;
	if (yych == 'E') goto yy950;
	if (yych == 'e') goto yy950;
	goto yy55;
yy839:
	yych = *++cur;
	if (yych == 'T') goto yy951;
	if (yych == 't') goto yy951;
	goto yy55;
yy840:
	yych = *++cur;
	if (yych == 'O') goto yy952;
	if (yych == 'o') goto yy952;
	goto yy55;
yy841:
	yych = *++cur;
	if (yych == 'C') goto yy953;
	if (yych == 'c') goto yy953;
	goto yy55;
yy842:
	yych = *++cur;
	if (yych == 'E') goto yy954;
	if (yych == 'e') goto yy954;
	goto yy55;
yy843:
	yych = *++cur;
	if (yych == 'S') goto yy955;
	if (yych == 's') goto yy955;
	goto yy55;
yy844:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 200 "tokenizer.re"
	{ KW(COMPLEX) }
#line 5715 "tokenizer.cpp"
yy846:
	yych = *++cur;
	if (yych == 'E') goto yy956;
	if (yych == 'e') goto yy956;
	goto yy55;
yy847:
	yych = *++cur;
	if (yych == 'S') goto yy957;
	if (yych == 's') goto yy957;
	goto yy55;
yy848:
	yych = *++cur;
	if (yych == 'O') goto yy959;
	if (yych == 'o') goto yy959;
	goto yy55;
yy849:
	yych = *++cur;
	if (yych == 'E') goto yy960;
	if (yych == 'e') goto yy960;
	goto yy55;
yy850:
	yych = *++cur;
	if (yych == 'L') goto yy962;
	if (yych == 'l') goto yy962;
	goto yy55;
yy851:
	yych = *++cur;
	if (yych == 'A') goto yy964;
	if (yych == 'a') goto yy964;
	goto yy55;
yy852:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 209 "tokenizer.re"
	{ KW(DEFAULT) }
#line 5754 "tokenizer.cpp"
yy854:
	yych = *++cur;
	if (yych == 'D') goto yy965;
	if (yych == 'd') goto yy965;
	goto yy55;
yy855:
	yych = *++cur;
	if (yych == 'O') goto yy967;
	if (yych == 'o') goto yy967;
	goto yy55;
yy856:
	yych = *++cur;
	if (yych == 'R') goto yy968;
	if (yych == 'r') goto yy968;
	goto yy55;
yy857:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 213 "tokenizer.re"
	{ KW(DOWHILE) }
#line 5778 "tokenizer.cpp"
yy859:
	yych = *++cur;
	if (yych == 'A') goto yy969;
	if (yych == 'a') goto yy969;
	goto yy55;
yy860:
	yych = *++cur;
	if (yych == 'R') goto yy970;
	if (yych == 'r') goto yy970;
	goto yy55;
yy861:
	yych = *++cur;
	if (yych == 'O') goto yy971;
	if (yych == 'o') goto yy971;
	goto yy79;
yy862:
	yych = *++cur;
	if (yych == 'C') goto yy972;
	if (yych == 'c') goto yy972;
	goto yy79;
yy863:
	yych = *++cur;
	if (yych == 'T') goto yy973;
	if (yych == 't') goto yy973;
	goto yy79;
yy864:
	yych = *++cur;
	if (yych == 'M') goto yy974;
	if (yych == 'm') goto yy974;
	goto yy79;
yy865:
	yych = *++cur;
	if (yych == 'A') goto yy976;
	if (yych == 'a') goto yy976;
	goto yy79;
yy866:
	yych = *++cur;
	if (yych == 'C') goto yy977;
	if (yych == 'c') goto yy977;
	goto yy79;
yy867:
	yych = *++cur;
	if (yych == 'E') goto yy978;
	if (yych == 'e') goto yy978;
	goto yy79;
yy868:
	yych = *++cur;
	if (yych == 'U') goto yy979;
	if (yych == 'u') goto yy979;
	goto yy79;
yy869:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy980;
		if (yych <= 'F') goto yy79;
		goto yy981;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy79;
			goto yy980;
		} else {
			if (yych == 'g') goto yy981;
			goto yy79;
		}
	}
yy870:
	yych = *++cur;
	if (yych == 'E') goto yy982;
	if (yych == 'e') goto yy982;
	goto yy79;
yy871:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy983;
		if (yych <= 'Q') goto yy79;
		goto yy984;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy79;
			goto yy983;
		} else {
			if (yych == 'r') goto yy984;
			goto yy79;
		}
	}
yy872:
	yych = *++cur;
	if (yych == 'E') goto yy985;
	if (yych == 'e') goto yy985;
	goto yy79;
yy873:
	yych = *++cur;
	if (yych == 'R') goto yy987;
	if (yych == 'r') goto yy987;
	goto yy79;
yy874:
	yych = *++cur;
	if (yych == 'C') goto yy988;
	if (yych == 'c') goto yy988;
	goto yy55;
yy875:
	yych = *++cur;
	if (yych == 'K') goto yy989;
	if (yych == 'k') goto yy989;
	goto yy55;
yy876:
	yych = *++cur;
	if (yych == 'I') goto yy991;
	if (yych == 'i') goto yy991;
	goto yy55;
yy877:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 250 "tokenizer.re"
	{ KW(ENDENUM) }
#line 5897 "tokenizer.cpp"
yy879:
	yych = *++cur;
	if (yych == 'L') goto yy992;
	if (yych == 'l') goto yy992;
	goto yy55;
yy880:
	yych = *++cur;
	if (yych == 'T') goto yy993;
	if (yych == 't') goto yy993;
	goto yy55;
yy881:
	yych = *++cur;
	if (yych == 'R') goto yy994;
	if (yych == 'r') goto yy994;
	goto yy55;
yy882:
	yych = *++cur;
	if (yych == 'L') goto yy995;
	if (yych == 'l') goto yy995;
	goto yy55;
yy883:
	yych = *++cur;
	if (yych == 'E') goto yy996;
	if (yych == 'e') goto yy996;
	goto yy55;
yy884:
	yych = *++cur;
	if (yych == 'R') goto yy997;
	if (yych == 'r') goto yy997;
	goto yy55;
yy885:
	yych = *++cur;
	if (yych == 'C') goto yy998;
	if (yych == 'c') goto yy998;
	goto yy55;
yy886:
	yych = *++cur;
	if (yych == 'O') goto yy999;
	if (yych == 'o') goto yy999;
	goto yy55;
yy887:
	yych = *++cur;
	if (yych == 'O') goto yy1000;
	if (yych == 'o') goto yy1000;
	goto yy55;
yy888:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 271 "tokenizer.re"
	{ KW(ENDTYPE) }
#line 5951 "tokenizer.cpp"
yy890:
	yych = *++cur;
	if (yych == 'E') goto yy1001;
	if (yych == 'e') goto yy1001;
	goto yy55;
yy891:
	yych = *++cur;
	if (yych == 'T') goto yy1003;
	if (yych == 't') goto yy1003;
	goto yy55;
yy892:
	yych = *++cur;
	if (yych == 'E') goto yy1004;
	if (yych == 'e') goto yy1004;
	goto yy55;
yy893:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 287 "tokenizer.re"
	{ KW(EXTENDS) }
#line 5975 "tokenizer.cpp"
yy895:
	yych = *++cur;
	if (yych == 'L') goto yy1005;
	if (yych == 'l') goto yy1005;
	goto yy55;
yy896:
	yych = *++cur;
	if (yych == 'E') goto yy1007;
	if (yych == 'e') goto yy1007;
	goto yy55;
yy897:
	yych = *++cur;
	if (yych == 'N') goto yy1008;
	if (yych == 'n') goto yy1008;
	goto yy55;
yy898:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 307 "tokenizer.re"
	{ KW(GENERIC) }
#line 5999 "tokenizer.cpp"
yy900:
	yych = *++cur;
	if (yych == 'T') goto yy1010;
	if (yych == 't') goto yy1010;
	goto yy55;
yy901:
	yyaccept = 12;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych >= '\t') goto yy1012;
		} else {
			if (yych == '\v') goto yy1012;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1012;
			if (yych >= ' ') goto yy1012;
		} else {
			if (yych == '_') goto yy143;
		}
	}
yy902:
#line 315 "tokenizer.re"
	{ KW(INCLUDE) }
#line 6028 "tokenizer.cpp"
yy903:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 318 "tokenizer.re"
	{ KW(INQUIRE) }
#line 6037 "tokenizer.cpp"
yy905:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 319 "tokenizer.re"
	{ KW(INTEGER) }
#line 6046 "tokenizer.cpp"
yy907:
	yych = *++cur;
	if (yych == 'C') goto yy1014;
	if (yych == 'c') goto yy1014;
	goto yy55;
yy908:
	yych = *++cur;
	if (yych == 'I') goto yy1015;
	if (yych == 'i') goto yy1015;
	goto yy55;
yy909:
	yych = *++cur;
	if (yych == 'N') goto yy1016;
	if (yych == 'n') goto yy1016;
	goto yy55;
yy910:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 328 "tokenizer.re"
	{ KW(LOGICAL) }
#line 6070 "tokenizer.cpp"
yy912:
	yych = *++cur;
	if (yych == 'T') goto yy1017;
	if (yych == 't') goto yy1017;
	goto yy55;
yy913:
	yych = *++cur;
	if (yych == 'R') goto yy1019;
	if (yych == 'r') goto yy1019;
	goto yy55;
yy914:
	yych = *++cur;
	if (yych == 'R') goto yy1020;
	if (yych == 'r') goto yy1020;
	goto yy55;
yy915:
	yych = *++cur;
	if (yych == 'U') goto yy1021;
	if (yych == 'u') goto yy1021;
	goto yy55;
yy916:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 338 "tokenizer.re"
	{ KW(NULLIFY) }
#line 6099 "tokenizer.cpp"
yy918:
	yych = *++cur;
	if (yych == 'R') goto yy1022;
	if (yych == 'r') goto yy1022;
	goto yy55;
yy919:
	yych = *++cur;
	if (yych == 'L') goto yy1024;
	if (yych == 'l') goto yy1024;
	goto yy55;
yy920:
	yych = *++cur;
	if (yych == 'E') goto yy1026;
	if (yych == 'e') goto yy1026;
	goto yy55;
yy921:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 346 "tokenizer.re"
	{ KW(POINTER) }
#line 6123 "tokenizer.cpp"
yy923:
	yych = *++cur;
	if (yych == 'O') goto yy1027;
	if (yych == 'o') goto yy1027;
	goto yy55;
yy924:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 350 "tokenizer.re"
	{ KW(PRIVATE) }
#line 6137 "tokenizer.cpp"
yy926:
	yych = *++cur;
	if (yych == 'R') goto yy1028;
	if (yych == 'r') goto yy1028;
	goto yy55;
yy927:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 352 "tokenizer.re"
	{ KW(PROGRAM) }
#line 6151 "tokenizer.cpp"
yy929:
	yych = *++cur;
	if (yych == 'E') goto yy1029;
	if (yych == 'e') goto yy1029;
	goto yy55;
yy930:
	yych = *++cur;
	if (yych == 'V') goto yy1030;
	if (yych == 'v') goto yy1030;
	goto yy55;
yy931:
	yych = *++cur;
	if (yych == 'A') goto yy1031;
	if (yych == 'a') goto yy1031;
	goto yy55;
yy932:
	yych = *++cur;
	if (yych == 'A') goto yy1032;
	if (yych == 'a') goto yy1032;
	goto yy55;
yy933:
	yych = *++cur;
	if (yych == 'Y') goto yy1033;
	if (yych == 'y') goto yy1033;
	goto yy55;
yy934:
	yych = *++cur;
	if (yych == 'E') goto yy1034;
	if (yych == 'e') goto yy1034;
	goto yy55;
yy935:
	yych = *++cur;
	if (yych == 'L') goto yy1036;
	if (yych == 'l') goto yy1036;
	goto yy55;
yy936:
	yych = *++cur;
	if (yych == 'I') goto yy1037;
	if (yych == 'i') goto yy1037;
	goto yy55;
yy937:
	yych = *++cur;
	if (yych == 'M') goto yy1038;
	if (yych == 'm') goto yy1038;
	goto yy55;
yy938:
	yych = *++cur;
	if (yych == 'T') goto yy1039;
	if (yych == 't') goto yy1039;
	goto yy55;
yy939:
	yych = *++cur;
	if (yych == 'E') goto yy1040;
	if (yych == 'e') goto yy1040;
	goto yy55;
yy940:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy1042;
		if (yych <= '@') goto yy79;
		goto yy1044;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy1044;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1044;
			goto yy79;
		}
	}
yy941:
	yych = *++cur;
	if (yych <= '/') goto yy704;
	if (yych <= '9') goto yy941;
	goto yy704;
yy943:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy704;
		if (yych <= '9') goto yy943;
		if (yych <= '@') goto yy704;
		goto yy943;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy704;
			goto yy943;
		} else {
			if (yych <= '`') goto yy704;
			if (yych <= 'z') goto yy943;
			goto yy704;
		}
	}
yy945:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 183 "tokenizer.re"
	{ KW(ABSTRACT) }
#line 6254 "tokenizer.cpp"
yy947:
	yych = *++cur;
	if (yych == 'B') goto yy1046;
	if (yych == 'b') goto yy1046;
	goto yy55;
yy948:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 186 "tokenizer.re"
	{ KW(ALLOCATE) }
#line 6268 "tokenizer.cpp"
yy950:
	yych = *++cur;
	if (yych == 'N') goto yy1047;
	if (yych == 'n') goto yy1047;
	goto yy55;
yy951:
	yych = *++cur;
	if (yych == 'E') goto yy1048;
	if (yych == 'e') goto yy1048;
	goto yy55;
yy952:
	yych = *++cur;
	if (yych == 'N') goto yy1050;
	if (yych == 'n') goto yy1050;
	goto yy55;
yy953:
	yych = *++cur;
	if (yych == 'E') goto yy1051;
	if (yych == 'e') goto yy1051;
	goto yy55;
yy954:
	yych = *++cur;
	if (yych == 'R') goto yy1053;
	if (yych == 'r') goto yy1053;
	goto yy55;
yy955:
	yych = *++cur;
	if (yych == 'I') goto yy1055;
	if (yych == 'i') goto yy1055;
	goto yy55;
yy956:
	yych = *++cur;
	if (yych == 'N') goto yy1056;
	if (yych == 'n') goto yy1056;
	goto yy55;
yy957:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 202 "tokenizer.re"
	{ KW(CONTAINS) }
#line 6312 "tokenizer.cpp"
yy959:
	yych = *++cur;
	if (yych == 'U') goto yy1057;
	if (yych == 'u') goto yy1057;
	goto yy55;
yy960:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 204 "tokenizer.re"
	{ KW(CONTINUE) }
#line 6326 "tokenizer.cpp"
yy962:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 205 "tokenizer.re"
	{ KW(CRITICAL) }
#line 6335 "tokenizer.cpp"
yy964:
	yych = *++cur;
	if (yych == 'T') goto yy1058;
	if (yych == 't') goto yy1058;
	goto yy55;
yy965:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 210 "tokenizer.re"
	{ KW(DEFERRED) }
#line 6349 "tokenizer.cpp"
yy967:
	yych = *++cur;
	if (yych == 'N') goto yy1059;
	if (yych == 'n') goto yy1059;
	goto yy55;
yy968:
	yych = *++cur;
	if (yych == 'E') goto yy1061;
	if (yych == 'e') goto yy1061;
	goto yy55;
yy969:
	yych = *++cur;
	if (yych == 'L') goto yy1062;
	if (yych == 'l') goto yy1062;
	goto yy55;
yy970:
	yych = *++cur;
	if (yych == 'E') goto yy1064;
	if (yych == 'e') goto yy1064;
	goto yy55;
yy971:
	yych = *++cur;
	if (yych == 'C') goto yy1066;
	if (yych == 'c') goto yy1066;
	goto yy79;
yy972:
	yych = *++cur;
	if (yych == 'K') goto yy1067;
	if (yych == 'k') goto yy1067;
	goto yy79;
yy973:
	yych = *++cur;
	if (yych == 'I') goto yy1069;
	if (yych == 'i') goto yy1069;
	goto yy79;
yy974:
	++cur;
#line 249 "tokenizer.re"
	{ KW(END_ENUM) }
#line 6389 "tokenizer.cpp"
yy976:
	yych = *++cur;
	if (yych == 'L') goto yy1070;
	if (yych == 'l') goto yy1070;
	goto yy79;
yy977:
	yych = *++cur;
	if (yych == 'T') goto yy1071;
	if (yych == 't') goto yy1071;
	goto yy79;
yy978:
	yych = *++cur;
	if (yych == 'R') goto yy1072;
	if (yych == 'r') goto yy1072;
	goto yy79;
yy979:
	yych = *++cur;
	if (yych == 'L') goto yy1073;
	if (yych == 'l') goto yy1073;
	goto yy79;
yy980:
	yych = *++cur;
	if (yych == 'E') goto yy1074;
	if (yych == 'e') goto yy1074;
	goto yy79;
yy981:
	yych = *++cur;
	if (yych == 'R') goto yy1075;
	if (yych == 'r') goto yy1075;
	goto yy79;
yy982:
	yych = *++cur;
	if (yych == 'C') goto yy1076;
	if (yych == 'c') goto yy1076;
	goto yy79;
yy983:
	yych = *++cur;
	if (yych == 'O') goto yy1077;
	if (yych == 'o') goto yy1077;
	goto yy79;
yy984:
	yych = *++cur;
	if (yych == 'O') goto yy1078;
	if (yych == 'o') goto yy1078;
	goto yy79;
yy985:
	++cur;
#line 270 "tokenizer.re"
	{ KW(END_TYPE) }
#line 6439 "tokenizer.cpp"
yy987:
	yych = *++cur;
	if (yych == 'E') goto yy1079;
	if (yych == 'e') goto yy1079;
	goto yy79;
yy988:
	yych = *++cur;
	if (yych == 'I') goto yy1081;
	if (yych == 'i') goto yy1081;
	goto yy55;
yy989:
	yyaccept = 13;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= '/') {
		if (yych <= '\v') {
			if (yych == '\t') goto yy1082;
			if (yych >= '\v') goto yy1082;
		} else {
			if (yych <= '\r') {
				if (yych >= '\r') goto yy1082;
			} else {
				if (yych == ' ') goto yy1082;
			}
		}
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') {
				if (yych <= '9') goto yy54;
			} else {
				if (yych == 'D') goto yy1084;
				goto yy54;
			}
		} else {
			if (yych <= 'c') {
				if (yych >= 'a') goto yy54;
			} else {
				if (yych <= 'd') goto yy1084;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy990:
#line 233 "tokenizer.re"
	{ KW(ENDBLOCK) }
#line 6487 "tokenizer.cpp"
yy991:
	yych = *++cur;
	if (yych == 'C') goto yy1085;
	if (yych == 'c') goto yy1085;
	goto yy55;
yy992:
	yych = *++cur;
	if (yych == 'L') goto yy1086;
	if (yych == 'l') goto yy1086;
	goto yy55;
yy993:
	yych = *++cur;
	if (yych == 'I') goto yy1088;
	if (yych == 'i') goto yy1088;
	goto yy55;
yy994:
	yych = *++cur;
	if (yych == 'F') goto yy1089;
	if (yych == 'f') goto yy1089;
	goto yy55;
yy995:
	yych = *++cur;
	if (yych == 'E') goto yy1090;
	if (yych == 'e') goto yy1090;
	goto yy55;
yy996:
	yych = *++cur;
	if (yych == 'D') goto yy1092;
	if (yych == 'd') goto yy1092;
	goto yy55;
yy997:
	yych = *++cur;
	if (yych == 'A') goto yy1093;
	if (yych == 'a') goto yy1093;
	goto yy55;
yy998:
	yych = *++cur;
	if (yych == 'T') goto yy1094;
	if (yych == 't') goto yy1094;
	goto yy55;
yy999:
	yych = *++cur;
	if (yych == 'D') goto yy1096;
	if (yych == 'd') goto yy1096;
	goto yy55;
yy1000:
	yych = *++cur;
	if (yych == 'U') goto yy1097;
	if (yych == 'u') goto yy1097;
	goto yy55;
yy1001:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 277 "tokenizer.re"
	{ KW(ENDWHERE) }
#line 6546 "tokenizer.cpp"
yy1003:
	yych = *++cur;
	if (yych == 'O') goto yy1098;
	if (yych == 'o') goto yy1098;
	goto yy55;
yy1004:
	yych = *++cur;
	if (yych == 'N') goto yy1099;
	if (yych == 'n') goto yy1099;
	goto yy55;
yy1005:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 288 "tokenizer.re"
	{ KW(EXTERNAL) }
#line 6565 "tokenizer.cpp"
yy1007:
	yych = *++cur;
	if (yych == 'D') goto yy1100;
	if (yych == 'd') goto yy1100;
	goto yy55;
yy1008:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 306 "tokenizer.re"
	{ KW(FUNCTION) }
#line 6579 "tokenizer.cpp"
yy1010:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 311 "tokenizer.re"
	{ KW(IMPLICIT) }
#line 6588 "tokenizer.cpp"
yy1012:
	yych = *++cur;
	if (yych <= '"') {
		if (yych <= '\f') {
			if (yych <= '\t') {
				if (yych <= 0x08) goto yy79;
				goto yy1012;
			} else {
				if (yych == '\v') goto yy1012;
				goto yy79;
			}
		} else {
			if (yych <= 0x1F) {
				if (yych <= '\r') goto yy1012;
				goto yy79;
			} else {
				if (yych <= ' ') goto yy1012;
				if (yych <= '!') goto yy79;
				goto yy1102;
			}
		}
	} else {
		if (yych <= '@') {
			if (yych <= '\'') {
				if (yych <= '&') goto yy79;
				goto yy1104;
			} else {
				if (yych <= '/') goto yy79;
				if (yych <= '9') goto yy1106;
				goto yy79;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy1108;
				if (yych <= '^') goto yy79;
				goto yy1108;
			} else {
				if (yych <= '`') goto yy79;
				if (yych <= 'z') goto yy1108;
				goto yy79;
			}
		}
	}
yy1014:
	yych = *++cur;
	if (yych == 'E') goto yy1110;
	if (yych == 'e') goto yy1110;
	goto yy55;
yy1015:
	yych = *++cur;
	if (yych == 'C') goto yy1112;
	if (yych == 'c') goto yy1112;
	goto yy55;
yy1016:
	yych = *++cur;
	if (yych == 'I') goto yy1114;
	if (yych == 'i') goto yy1114;
	goto yy55;
yy1017:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 332 "tokenizer.re"
	{ KW(NAMELIST) }
#line 6655 "tokenizer.cpp"
yy1019:
	yych = *++cur;
	if (yych == 'I') goto yy1115;
	if (yych == 'i') goto yy1115;
	goto yy55;
yy1020:
	yych = *++cur;
	if (yych == 'R') goto yy1116;
	if (yych == 'r') goto yy1116;
	goto yy55;
yy1021:
	yych = *++cur;
	if (yych == 'R') goto yy1117;
	if (yych == 'r') goto yy1117;
	goto yy55;
yy1022:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 341 "tokenizer.re"
	{ KW(OPERATOR) }
#line 6679 "tokenizer.cpp"
yy1024:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 342 "tokenizer.re"
	{ KW(OPTIONAL) }
#line 6688 "tokenizer.cpp"
yy1026:
	yych = *++cur;
	if (yych == 'R') goto yy1118;
	if (yych == 'r') goto yy1118;
	goto yy55;
yy1027:
	yych = *++cur;
	if (yych == 'N') goto yy1120;
	if (yych == 'n') goto yy1120;
	goto yy55;
yy1028:
	yych = *++cur;
	if (yych == 'E') goto yy1122;
	if (yych == 'e') goto yy1122;
	goto yy55;
yy1029:
	yych = *++cur;
	if (yych == 'D') goto yy1124;
	if (yych == 'd') goto yy1124;
	goto yy55;
yy1030:
	yych = *++cur;
	if (yych == 'E') goto yy1126;
	if (yych == 'e') goto yy1126;
	goto yy55;
yy1031:
	yych = *++cur;
	if (yych == 'S') goto yy1128;
	if (yych == 's') goto yy1128;
	goto yy55;
yy1032:
	yych = *++cur;
	if (yych == 'N') goto yy1129;
	if (yych == 'n') goto yy1129;
	goto yy55;
yy1033:
	yych = *++cur;
	if (yych == 'P') goto yy1130;
	if (yych == 'p') goto yy1130;
	goto yy55;
yy1034:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 370 "tokenizer.re"
	{ KW(SEQUENCE) }
#line 6737 "tokenizer.cpp"
yy1036:
	yych = *++cur;
	if (yych == 'E') goto yy1131;
	if (yych == 'e') goto yy1131;
	goto yy55;
yy1037:
	yych = *++cur;
	if (yych == 'N') goto yy1133;
	if (yych == 'n') goto yy1133;
	goto yy55;
yy1038:
	yych = *++cur;
	if (yych == 'B') goto yy1134;
	if (yych == 'b') goto yy1134;
	goto yy55;
yy1039:
	yych = *++cur;
	if (yych == 'T') goto yy1135;
	if (yych == 't') goto yy1135;
	goto yy55;
yy1040:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 387 "tokenizer.re"
	{ KW(VOLATILE) }
#line 6766 "tokenizer.cpp"
yy1042:
	yych = *++cur;
	if (yych <= '/') goto yy834;
	if (yych <= '9') goto yy1042;
	goto yy834;
yy1044:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy834;
		if (yych <= '9') goto yy1044;
		if (yych <= '@') goto yy834;
		goto yy1044;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy834;
			goto yy1044;
		} else {
			if (yych <= '`') goto yy834;
			if (yych <= 'z') goto yy1044;
			goto yy834;
		}
	}
yy1046:
	yych = *++cur;
	if (yych == 'L') goto yy1136;
	if (yych == 'l') goto yy1136;
	goto yy55;
yy1047:
	yych = *++cur;
	if (yych == 'T') goto yy1137;
	if (yych == 't') goto yy1137;
	goto yy55;
yy1048:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 188 "tokenizer.re"
	{ KW(ASSOCIATE) }
#line 6807 "tokenizer.cpp"
yy1050:
	yych = *++cur;
	if (yych == 'O') goto yy1139;
	if (yych == 'o') goto yy1139;
	goto yy55;
yy1051:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 190 "tokenizer.re"
	{ KW(BACKSPACE) }
#line 6821 "tokenizer.cpp"
yy1053:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 195 "tokenizer.re"
	{ KW(CHARACTER) }
#line 6830 "tokenizer.cpp"
yy1055:
	yych = *++cur;
	if (yych == 'O') goto yy1140;
	if (yych == 'o') goto yy1140;
	goto yy55;
yy1056:
	yych = *++cur;
	if (yych == 'T') goto yy1141;
	if (yych == 't') goto yy1141;
	goto yy55;
yy1057:
	yych = *++cur;
	if (yych == 'S') goto yy1143;
	if (yych == 's') goto yy1143;
	goto yy55;
yy1058:
	yych = *++cur;
	if (yych == 'E') goto yy1145;
	if (yych == 'e') goto yy1145;
	goto yy55;
yy1059:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 211 "tokenizer.re"
	{ KW(DIMENSION) }
#line 6859 "tokenizer.cpp"
yy1061:
	yych = *++cur;
	if (yych == 'C') goto yy1147;
	if (yych == 'c') goto yy1147;
	goto yy55;
yy1062:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 216 "tokenizer.re"
	{ KW(ELEMENTAL) }
#line 6873 "tokenizer.cpp"
yy1064:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 219 "tokenizer.re"
	{ KW(ELSEWHERE) }
#line 6882 "tokenizer.cpp"
yy1066:
	yych = *++cur;
	if (yych == 'I') goto yy1148;
	if (yych == 'i') goto yy1148;
	goto yy79;
yy1067:
	yyaccept = 14;
	yych = *(mar = ++cur);
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1149;
		} else {
			if (yych != '\f') goto yy1149;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1149;
		} else {
			if (yych <= 'D') goto yy1151;
			if (yych == 'd') goto yy1151;
		}
	}
yy1068:
#line 232 "tokenizer.re"
	{ KW(END_BLOCK) }
#line 6908 "tokenizer.cpp"
yy1069:
	yych = *++cur;
	if (yych == 'C') goto yy1152;
	if (yych == 'c') goto yy1152;
	goto yy79;
yy1070:
	yych = *++cur;
	if (yych == 'L') goto yy1153;
	if (yych == 'l') goto yy1153;
	goto yy79;
yy1071:
	yych = *++cur;
	if (yych == 'I') goto yy1155;
	if (yych == 'i') goto yy1155;
	goto yy79;
yy1072:
	yych = *++cur;
	if (yych == 'F') goto yy1156;
	if (yych == 'f') goto yy1156;
	goto yy79;
yy1073:
	yych = *++cur;
	if (yych == 'E') goto yy1157;
	if (yych == 'e') goto yy1157;
	goto yy79;
yy1074:
	yych = *++cur;
	if (yych == 'D') goto yy1159;
	if (yych == 'd') goto yy1159;
	goto yy79;
yy1075:
	yych = *++cur;
	if (yych == 'A') goto yy1160;
	if (yych == 'a') goto yy1160;
	goto yy79;
yy1076:
	yych = *++cur;
	if (yych == 'T') goto yy1161;
	if (yych == 't') goto yy1161;
	goto yy79;
yy1077:
	yych = *++cur;
	if (yych == 'D') goto yy1163;
	if (yych == 'd') goto yy1163;
	goto yy79;
yy1078:
	yych = *++cur;
	if (yych == 'U') goto yy1164;
	if (yych == 'u') goto yy1164;
	goto yy79;
yy1079:
	++cur;
#line 276 "tokenizer.re"
	{ KW(END_WHERE) }
#line 6963 "tokenizer.cpp"
yy1081:
	yych = *++cur;
	if (yych == 'A') goto yy1165;
	if (yych == 'a') goto yy1165;
	goto yy55;
yy1082:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1082;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy1082;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1082;
			goto yy79;
		} else {
			if (yych <= 'D') goto yy1166;
			if (yych == 'd') goto yy1166;
			goto yy79;
		}
	}
yy1084:
	yych = *++cur;
	if (yych == 'A') goto yy1167;
	if (yych == 'a') goto yy1167;
	goto yy55;
yy1085:
	yych = *++cur;
	if (yych == 'A') goto yy1168;
	if (yych == 'a') goto yy1168;
	goto yy55;
yy1086:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 262 "tokenizer.re"
	{ KW(ENDFORALL) }
#line 7007 "tokenizer.cpp"
yy1088:
	yych = *++cur;
	if (yych == 'O') goto yy1169;
	if (yych == 'o') goto yy1169;
	goto yy55;
yy1089:
	yych = *++cur;
	if (yych == 'A') goto yy1170;
	if (yych == 'a') goto yy1170;
	goto yy55;
yy1090:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 227 "tokenizer.re"
	{ KW(ENDMODULE) }
#line 7026 "tokenizer.cpp"
yy1092:
	yych = *++cur;
	if (yych == 'U') goto yy1171;
	if (yych == 'u') goto yy1171;
	goto yy55;
yy1093:
	yych = *++cur;
	if (yych == 'M') goto yy1172;
	if (yych == 'm') goto yy1172;
	goto yy55;
yy1094:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 253 "tokenizer.re"
	{ KW(ENDSELECT) }
#line 7045 "tokenizer.cpp"
yy1096:
	yych = *++cur;
	if (yych == 'U') goto yy1174;
	if (yych == 'u') goto yy1174;
	goto yy55;
yy1097:
	yych = *++cur;
	if (yych == 'T') goto yy1175;
	if (yych == 't') goto yy1175;
	goto yy55;
yy1098:
	yych = *++cur;
	if (yych == 'R') goto yy1176;
	if (yych == 'r') goto yy1176;
	goto yy55;
yy1099:
	yych = *++cur;
	if (yych == 'C') goto yy1178;
	if (yych == 'c') goto yy1178;
	goto yy55;
yy1100:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 305 "tokenizer.re"
	{ KW(FORMATTED) }
#line 7074 "tokenizer.cpp"
yy1102:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '"') goto yy1179;
	goto yy1102;
yy1104:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '\'') goto yy1181;
	goto yy1104;
yy1106:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '9') goto yy1106;
	if (yych == '_') goto yy1183;
	goto yy79;
yy1108:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy1108;
		if (yych <= '@') goto yy79;
		goto yy1108;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy1184;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1108;
			goto yy79;
		}
	}
yy1110:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 321 "tokenizer.re"
	{ KW(INTERFACE) }
#line 7116 "tokenizer.cpp"
yy1112:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 322 "tokenizer.re"
	{ KW(INTRINSIC) }
#line 7125 "tokenizer.cpp"
yy1114:
	yych = *++cur;
	if (yych == 'T') goto yy1186;
	if (yych == 't') goto yy1186;
	goto yy55;
yy1115:
	yych = *++cur;
	if (yych == 'N') goto yy1188;
	if (yych == 'n') goto yy1188;
	goto yy55;
yy1116:
	yych = *++cur;
	if (yych == 'I') goto yy1189;
	if (yych == 'i') goto yy1189;
	goto yy55;
yy1117:
	yych = *++cur;
	if (yych == 'S') goto yy1190;
	if (yych == 's') goto yy1190;
	goto yy55;
yy1118:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 344 "tokenizer.re"
	{ KW(PARAMETER) }
#line 7154 "tokenizer.cpp"
yy1120:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 348 "tokenizer.re"
	{ KW(PRECISION) }
#line 7163 "tokenizer.cpp"
yy1122:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 351 "tokenizer.re"
	{ KW(PROCEDURE) }
#line 7172 "tokenizer.cpp"
yy1124:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 353 "tokenizer.re"
	{ KW(PROTECTED) }
#line 7181 "tokenizer.cpp"
yy1126:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 360 "tokenizer.re"
	{ KW(RECURSIVE) }
#line 7190 "tokenizer.cpp"
yy1128:
	yych = *++cur;
	if (yych == 'E') goto yy1191;
	if (yych == 'e') goto yy1191;
	goto yy55;
yy1129:
	yych = *++cur;
	if (yych == 'K') goto yy1193;
	if (yych == 'k') goto yy1193;
	goto yy55;
yy1130:
	yych = *++cur;
	if (yych == 'E') goto yy1195;
	if (yych == 'e') goto yy1195;
	goto yy55;
yy1131:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 375 "tokenizer.re"
	{ KW(SUBMODULE) }
#line 7214 "tokenizer.cpp"
yy1133:
	yych = *++cur;
	if (yych == 'E') goto yy1197;
	if (yych == 'e') goto yy1197;
	goto yy55;
yy1134:
	yych = *++cur;
	if (yych == 'E') goto yy1199;
	if (yych == 'e') goto yy1199;
	goto yy55;
yy1135:
	yych = *++cur;
	if (yych == 'E') goto yy1200;
	if (yych == 'e') goto yy1200;
	goto yy55;
yy1136:
	yych = *++cur;
	if (yych == 'E') goto yy1201;
	if (yych == 'e') goto yy1201;
	goto yy55;
yy1137:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 187 "tokenizer.re"
	{ KW(ASSIGNMENT) }
#line 7243 "tokenizer.cpp"
yy1139:
	yych = *++cur;
	if (yych == 'U') goto yy1203;
	if (yych == 'u') goto yy1203;
	goto yy55;
yy1140:
	yych = *++cur;
	if (yych == 'N') goto yy1204;
	if (yych == 'n') goto yy1204;
	goto yy55;
yy1141:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 201 "tokenizer.re"
	{ KW(CONCURRENT) }
#line 7262 "tokenizer.cpp"
yy1143:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 203 "tokenizer.re"
	{ KW(CONTIGUOUS) }
#line 7271 "tokenizer.cpp"
yy1145:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 208 "tokenizer.re"
	{ KW(DEALLOCATE) }
#line 7280 "tokenizer.cpp"
yy1147:
	yych = *++cur;
	if (yych == 'I') goto yy1206;
	if (yych == 'i') goto yy1206;
	goto yy55;
yy1148:
	yych = *++cur;
	if (yych == 'A') goto yy1207;
	if (yych == 'a') goto yy1207;
	goto yy79;
yy1149:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1149;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy1149;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1149;
			goto yy79;
		} else {
			if (yych <= 'D') goto yy1208;
			if (yych == 'd') goto yy1208;
			goto yy79;
		}
	}
yy1151:
	yych = *++cur;
	if (yych == 'A') goto yy1209;
	if (yych == 'a') goto yy1209;
	goto yy79;
yy1152:
	yych = *++cur;
	if (yych == 'A') goto yy1210;
	if (yych == 'a') goto yy1210;
	goto yy79;
yy1153:
	++cur;
#line 261 "tokenizer.re"
	{ KW(END_FORALL) }
#line 7325 "tokenizer.cpp"
yy1155:
	yych = *++cur;
	if (yych == 'O') goto yy1211;
	if (yych == 'o') goto yy1211;
	goto yy79;
yy1156:
	yych = *++cur;
	if (yych == 'A') goto yy1212;
	if (yych == 'a') goto yy1212;
	goto yy79;
yy1157:
	++cur;
#line 226 "tokenizer.re"
	{ KW(END_MODULE) }
#line 7340 "tokenizer.cpp"
yy1159:
	yych = *++cur;
	if (yych == 'U') goto yy1213;
	if (yych == 'u') goto yy1213;
	goto yy79;
yy1160:
	yych = *++cur;
	if (yych == 'M') goto yy1214;
	if (yych == 'm') goto yy1214;
	goto yy79;
yy1161:
	++cur;
#line 252 "tokenizer.re"
	{ KW(END_SELECT) }
#line 7355 "tokenizer.cpp"
yy1163:
	yych = *++cur;
	if (yych == 'U') goto yy1216;
	if (yych == 'u') goto yy1216;
	goto yy79;
yy1164:
	yych = *++cur;
	if (yych == 'T') goto yy1217;
	if (yych == 't') goto yy1217;
	goto yy79;
yy1165:
	yych = *++cur;
	if (yych == 'T') goto yy1218;
	if (yych == 't') goto yy1218;
	goto yy55;
yy1166:
	yych = *++cur;
	if (yych == 'A') goto yy1219;
	if (yych == 'a') goto yy1219;
	goto yy79;
yy1167:
	yych = *++cur;
	if (yych == 'T') goto yy1220;
	if (yych == 't') goto yy1220;
	goto yy55;
yy1168:
	yych = *++cur;
	if (yych == 'L') goto yy1221;
	if (yych == 'l') goto yy1221;
	goto yy55;
yy1169:
	yych = *++cur;
	if (yych == 'N') goto yy1223;
	if (yych == 'n') goto yy1223;
	goto yy55;
yy1170:
	yych = *++cur;
	if (yych == 'C') goto yy1225;
	if (yych == 'c') goto yy1225;
	goto yy55;
yy1171:
	yych = *++cur;
	if (yych == 'R') goto yy1226;
	if (yych == 'r') goto yy1226;
	goto yy55;
yy1172:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 224 "tokenizer.re"
	{ KW(ENDPROGRAM) }
#line 7409 "tokenizer.cpp"
yy1174:
	yych = *++cur;
	if (yych == 'L') goto yy1227;
	if (yych == 'l') goto yy1227;
	goto yy55;
yy1175:
	yych = *++cur;
	if (yych == 'I') goto yy1228;
	if (yych == 'i') goto yy1228;
	goto yy55;
yy1176:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 281 "tokenizer.re"
	{ KW(ENUMERATOR) }
#line 7428 "tokenizer.cpp"
yy1178:
	yych = *++cur;
	if (yych == 'E') goto yy1229;
	if (yych == 'e') goto yy1229;
	goto yy55;
yy1179:
	yyaccept = 15;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy1102;
yy1180:
#line 503 "tokenizer.re"
	{ continue; }
#line 7441 "tokenizer.cpp"
yy1181:
	yyaccept = 16;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy1104;
yy1182:
#line 504 "tokenizer.re"
	{ continue; }
#line 7449 "tokenizer.cpp"
yy1183:
	yych = *++cur;
	if (yych == '"') goto yy1102;
	if (yych == '\'') goto yy1104;
	goto yy79;
yy1184:
	yych = *++cur;
	if (yych <= '9') {
		if (yych <= '&') {
			if (yych == '"') goto yy1102;
			goto yy79;
		} else {
			if (yych <= '\'') goto yy1104;
			if (yych <= '/') goto yy79;
			goto yy1108;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy1108;
			goto yy79;
		} else {
			if (yych <= '_') goto yy1184;
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1108;
			goto yy79;
		}
	}
yy1186:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 327 "tokenizer.re"
	{ KW(LOCAL_INIT) }
#line 7486 "tokenizer.cpp"
yy1188:
	yych = *++cur;
	if (yych == 'S') goto yy1231;
	if (yych == 's') goto yy1231;
	goto yy55;
yy1189:
	yych = *++cur;
	if (yych == 'D') goto yy1232;
	if (yych == 'd') goto yy1232;
	goto yy55;
yy1190:
	yych = *++cur;
	if (yych == 'I') goto yy1233;
	if (yych == 'i') goto yy1233;
	goto yy55;
yy1191:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 367 "tokenizer.re"
	{ KW(SELECT_CASE) }
#line 7510 "tokenizer.cpp"
yy1193:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 368 "tokenizer.re"
	{ KW(SELECT_RANK) }
#line 7519 "tokenizer.cpp"
yy1195:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 369 "tokenizer.re"
	{ KW(SELECT_TYPE) }
#line 7528 "tokenizer.cpp"
yy1197:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 376 "tokenizer.re"
	{ KW(SUBROUTINE) }
#line 7537 "tokenizer.cpp"
yy1199:
	yych = *++cur;
	if (yych == 'R') goto yy1234;
	if (yych == 'r') goto yy1234;
	goto yy55;
yy1200:
	yych = *++cur;
	if (yych == 'D') goto yy1236;
	if (yych == 'd') goto yy1236;
	goto yy55;
yy1201:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 185 "tokenizer.re"
	{ KW(ALLOCATABLE) }
#line 7556 "tokenizer.cpp"
yy1203:
	yych = *++cur;
	if (yych == 'S') goto yy1238;
	if (yych == 's') goto yy1238;
	goto yy55;
yy1204:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 198 "tokenizer.re"
	{ KW(CODIMENSION) }
#line 7570 "tokenizer.cpp"
yy1206:
	yych = *++cur;
	if (yych == 'S') goto yy1240;
	if (yych == 's') goto yy1240;
	goto yy55;
yy1207:
	yych = *++cur;
	if (yych == 'T') goto yy1241;
	if (yych == 't') goto yy1241;
	goto yy79;
yy1208:
	yych = *++cur;
	if (yych == 'A') goto yy1242;
	if (yych == 'a') goto yy1242;
	goto yy79;
yy1209:
	yych = *++cur;
	if (yych == 'T') goto yy1243;
	if (yych == 't') goto yy1243;
	goto yy79;
yy1210:
	yych = *++cur;
	if (yych == 'L') goto yy1244;
	if (yych == 'l') goto yy1244;
	goto yy79;
yy1211:
	yych = *++cur;
	if (yych == 'N') goto yy1246;
	if (yych == 'n') goto yy1246;
	goto yy79;
yy1212:
	yych = *++cur;
	if (yych == 'C') goto yy1248;
	if (yych == 'c') goto yy1248;
	goto yy79;
yy1213:
	yych = *++cur;
	if (yych == 'R') goto yy1249;
	if (yych == 'r') goto yy1249;
	goto yy79;
yy1214:
	++cur;
#line 223 "tokenizer.re"
	{ KW(END_PROGRAM) }
#line 7615 "tokenizer.cpp"
yy1216:
	yych = *++cur;
	if (yych == 'L') goto yy1250;
	if (yych == 'l') goto yy1250;
	goto yy79;
yy1217:
	yych = *++cur;
	if (yych == 'I') goto yy1251;
	if (yych == 'i') goto yy1251;
	goto yy79;
yy1218:
	yych = *++cur;
	if (yych == 'E') goto yy1252;
	if (yych == 'e') goto yy1252;
	goto yy55;
yy1219:
	yych = *++cur;
	if (yych == 'T') goto yy1254;
	if (yych == 't') goto yy1254;
	goto yy79;
yy1220:
	yych = *++cur;
	if (yych == 'A') goto yy1255;
	if (yych == 'a') goto yy1255;
	goto yy55;
yy1221:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 259 "tokenizer.re"
	{ KW(ENDCRITICAL) }
#line 7649 "tokenizer.cpp"
yy1223:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 244 "tokenizer.re"
	{ KW(ENDFUNCTION) }
#line 7658 "tokenizer.cpp"
yy1225:
	yych = *++cur;
	if (yych == 'E') goto yy1257;
	if (yych == 'e') goto yy1257;
	goto yy55;
yy1226:
	yych = *++cur;
	if (yych == 'E') goto yy1259;
	if (yych == 'e') goto yy1259;
	goto yy55;
yy1227:
	yych = *++cur;
	if (yych == 'E') goto yy1261;
	if (yych == 'e') goto yy1261;
	goto yy55;
yy1228:
	yych = *++cur;
	if (yych == 'N') goto yy1263;
	if (yych == 'n') goto yy1263;
	goto yy55;
yy1229:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 282 "tokenizer.re"
	{ KW(EQUIVALENCE) }
#line 7687 "tokenizer.cpp"
yy1231:
	yych = *++cur;
	if (yych == 'I') goto yy1264;
	if (yych == 'i') goto yy1264;
	goto yy55;
yy1232:
	yych = *++cur;
	if (yych == 'A') goto yy1265;
	if (yych == 'a') goto yy1265;
	goto yy55;
yy1233:
	yych = *++cur;
	if (yych == 'V') goto yy1266;
	if (yych == 'v') goto yy1266;
	goto yy55;
yy1234:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 380 "tokenizer.re"
	{ KW(TEAM_NUMBER) }
#line 7711 "tokenizer.cpp"
yy1236:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 384 "tokenizer.re"
	{ KW(UNFORMATTED) }
#line 7720 "tokenizer.cpp"
yy1238:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 189 "tokenizer.re"
	{ KW(ASYNCHRONOUS) }
#line 7729 "tokenizer.cpp"
yy1240:
	yych = *++cur;
	if (yych == 'I') goto yy1267;
	if (yych == 'i') goto yy1267;
	goto yy55;
yy1241:
	yych = *++cur;
	if (yych == 'E') goto yy1268;
	if (yych == 'e') goto yy1268;
	goto yy79;
yy1242:
	yych = *++cur;
	if (yych == 'T') goto yy1270;
	if (yych == 't') goto yy1270;
	goto yy79;
yy1243:
	yych = *++cur;
	if (yych == 'A') goto yy1271;
	if (yych == 'a') goto yy1271;
	goto yy79;
yy1244:
	++cur;
#line 258 "tokenizer.re"
	{ KW(END_CRITICAL) }
#line 7754 "tokenizer.cpp"
yy1246:
	++cur;
#line 243 "tokenizer.re"
	{ KW(END_FUNCTION) }
#line 7759 "tokenizer.cpp"
yy1248:
	yych = *++cur;
	if (yych == 'E') goto yy1273;
	if (yych == 'e') goto yy1273;
	goto yy79;
yy1249:
	yych = *++cur;
	if (yych == 'E') goto yy1275;
	if (yych == 'e') goto yy1275;
	goto yy79;
yy1250:
	yych = *++cur;
	if (yych == 'E') goto yy1277;
	if (yych == 'e') goto yy1277;
	goto yy79;
yy1251:
	yych = *++cur;
	if (yych == 'N') goto yy1279;
	if (yych == 'n') goto yy1279;
	goto yy79;
yy1252:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 256 "tokenizer.re"
	{ KW(ENDASSOCIATE) }
#line 7788 "tokenizer.cpp"
yy1254:
	yych = *++cur;
	if (yych == 'A') goto yy1280;
	if (yych == 'a') goto yy1280;
	goto yy79;
yy1255:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 238 "tokenizer.re"
	{ KW(ENDBLOCKDATA) }
#line 7802 "tokenizer.cpp"
yy1257:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 268 "tokenizer.re"
	{ KW(ENDINTERFACE) }
#line 7811 "tokenizer.cpp"
yy1259:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 247 "tokenizer.re"
	{ KW(ENDPROCEDURE) }
#line 7820 "tokenizer.cpp"
yy1261:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 230 "tokenizer.re"
	{ KW(ENDSUBMODULE) }
#line 7829 "tokenizer.cpp"
yy1263:
	yych = *++cur;
	if (yych == 'E') goto yy1282;
	if (yych == 'e') goto yy1282;
	goto yy55;
yy1264:
	yych = *++cur;
	if (yych == 'C') goto yy1284;
	if (yych == 'c') goto yy1284;
	goto yy55;
yy1265:
	yych = *++cur;
	if (yych == 'B') goto yy1286;
	if (yych == 'b') goto yy1286;
	goto yy55;
yy1266:
	yych = *++cur;
	if (yych == 'E') goto yy1287;
	if (yych == 'e') goto yy1287;
	goto yy55;
yy1267:
	yych = *++cur;
	if (yych == 'O') goto yy1289;
	if (yych == 'o') goto yy1289;
	goto yy55;
yy1268:
	++cur;
#line 255 "tokenizer.re"
	{ KW(END_ASSOCIATE) }
#line 7859 "tokenizer.cpp"
yy1270:
	yych = *++cur;
	if (yych == 'A') goto yy1290;
	if (yych == 'a') goto yy1290;
	goto yy79;
yy1271:
	++cur;
#line 237 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 7869 "tokenizer.cpp"
yy1273:
	++cur;
#line 267 "tokenizer.re"
	{ KW(END_INTERFACE) }
#line 7874 "tokenizer.cpp"
yy1275:
	++cur;
#line 246 "tokenizer.re"
	{ KW(END_PROCEDURE) }
#line 7879 "tokenizer.cpp"
yy1277:
	++cur;
#line 229 "tokenizer.re"
	{ KW(END_SUBMODULE) }
#line 7884 "tokenizer.cpp"
yy1279:
	yych = *++cur;
	if (yych == 'E') goto yy1292;
	if (yych == 'e') goto yy1292;
	goto yy79;
yy1280:
	++cur;
#line 236 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 7894 "tokenizer.cpp"
yy1282:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 241 "tokenizer.re"
	{ KW(ENDSUBROUTINE) }
#line 7903 "tokenizer.cpp"
yy1284:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 334 "tokenizer.re"
	{ KW(NON_INTRINSIC) }
#line 7912 "tokenizer.cpp"
yy1286:
	yych = *++cur;
	if (yych == 'L') goto yy1294;
	if (yych == 'l') goto yy1294;
	goto yy55;
yy1287:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 336 "tokenizer.re"
	{ KW(NON_RECURSIVE) }
#line 7926 "tokenizer.cpp"
yy1289:
	yych = *++cur;
	if (yych == 'N') goto yy1295;
	if (yych == 'n') goto yy1295;
	goto yy55;
yy1290:
	++cur;
#line 235 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 7936 "tokenizer.cpp"
yy1292:
	++cur;
#line 240 "tokenizer.re"
	{ KW(END_SUBROUTINE) }
#line 7941 "tokenizer.cpp"
yy1294:
	yych = *++cur;
	if (yych == 'E') goto yy1297;
	if (yych == 'e') goto yy1297;
	goto yy55;
yy1295:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 215 "tokenizer.re"
	{ KW(DOUBLE_PRECISION) }
#line 7955 "tokenizer.cpp"
yy1297:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 335 "tokenizer.re"
	{ KW(NON_OVERRIDABLE) }
#line 7964 "tokenizer.cpp"
}
#line 511 "tokenizer.re"

    }
}

std::string token(unsigned char *tok, unsigned char* cur)
{
    return std::string((char *)tok, cur - tok);
}

void token_loc(Location &loc)
{
    loc.first_line = 1;
    loc.last_line = 1;
    loc.first_column = 1;
    loc.last_column = 1;
}

void lex_format(unsigned char *&cur, Location &loc,
        unsigned char *&start) {
    int num_paren = 0;
    for (;;) {
        unsigned char *tok = cur;
        unsigned char *mar;
        
#line 7991 "tokenizer.cpp"
{
	unsigned char yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		  0, 208, 208, 208, 208, 208, 208, 208, 
		208, 244, 176, 244, 208, 244, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		244, 208, 192, 208, 208, 208, 208,  80, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		216, 216, 216, 216, 216, 216, 216, 216, 
		216, 216, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
	};
	yych = *cur;
	if (yybm[0+yych] & 4) {
		goto yy1305;
	}
	switch (yych) {
	case 0x00:	goto yy1301;
	case '"':	goto yy1308;
	case '&':	goto yy1309;
	case '\'':	goto yy1310;
	case '(':	goto yy1311;
	case ')':	goto yy1313;
	case '*':	goto yy1315;
	case ',':	goto yy1316;
	case '/':
	case ':':	goto yy1318;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1320;
	case 'A':
	case 'a':	goto yy1321;
	case 'B':
	case 'I':
	case 'O':
	case 'Z':
	case 'b':
	case 'i':
	case 'o':
	case 'z':	goto yy1324;
	case 'D':
	case 'F':
	case 'd':
	case 'f':	goto yy1325;
	case 'E':
	case 'e':	goto yy1326;
	case 'G':
	case 'g':	goto yy1327;
	case 'L':
	case 'l':	goto yy1328;
	case 'P':
	case 'p':	goto yy1329;
	case 'T':
	case 't':	goto yy1330;
	default:	goto yy1303;
	}
yy1301:
	++cur;
#line 605 "tokenizer.re"
	{
                token_loc(loc);
                std::string t = token(tok, cur);
                throw LFortran::TokenizerError("End of file not expected",
                        loc, t);
            }
#line 8089 "tokenizer.cpp"
yy1303:
	++cur;
yy1304:
#line 571 "tokenizer.re"
	{
                token_loc(loc);
                std::string t = token(tok, cur);
                throw LFortran::TokenizerError("token '" + t
                    + "' is not recognized", loc, t);
            }
#line 8100 "tokenizer.cpp"
yy1305:
	yych = *++cur;
	if (yybm[0+yych] & 4) {
		goto yy1305;
	}
#line 611 "tokenizer.re"
	{ continue; }
#line 8108 "tokenizer.cpp"
yy1308:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy1304;
	goto yy1332;
yy1309:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= 0x08) goto yy1304;
		if (yych <= '\v') goto yy1337;
		goto yy1304;
	} else {
		if (yych <= '\r') goto yy1337;
		if (yych <= 0x1F) goto yy1304;
		if (yych <= '!') goto yy1337;
		goto yy1304;
	}
yy1310:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy1304;
	goto yy1344;
yy1311:
	++cur;
#line 577 "tokenizer.re"
	{
                if (num_paren == 0) {
                    num_paren++;
                    start = cur;
                    continue;
                } else {
                    cur--;
                    unsigned char *tmp;
                    lex_format(cur, loc, tmp);
                    continue;
                }
            }
#line 8147 "tokenizer.cpp"
yy1313:
	++cur;
#line 601 "tokenizer.re"
	{
                LFORTRAN_ASSERT(num_paren == 1);
                return;
            }
#line 8155 "tokenizer.cpp"
yy1315:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1304;
			goto yy1347;
		} else {
			if (yych == '\v') goto yy1347;
			goto yy1304;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1347;
			if (yych <= 0x1F) goto yy1304;
			goto yy1347;
		} else {
			if (yych == '(') goto yy1349;
			goto yy1304;
		}
	}
yy1316:
	++cur;
#line 612 "tokenizer.re"
	{ continue; }
#line 8181 "tokenizer.cpp"
yy1318:
	++cur;
yy1319:
#line 617 "tokenizer.re"
	{ continue; }
#line 8187 "tokenizer.cpp"
yy1320:
	yyaccept = 0;
	yych = *(mar = ++cur);
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':
	case '(':
	case '/':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'I':
	case 'L':
	case 'O':
	case 'P':
	case 'X':
	case 'Z':
	case 'a':
	case 'b':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'i':
	case 'l':
	case 'o':
	case 'p':
	case 'x':
	case 'z':	goto yy1356;
	default:	goto yy1304;
	}
yy1321:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1321;
	}
yy1323:
#line 616 "tokenizer.re"
	{ continue; }
#line 8242 "tokenizer.cpp"
yy1324:
	yych = *++cur;
	if (yych <= '/') goto yy1304;
	if (yych <= '9') goto yy1362;
	goto yy1304;
yy1325:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '/') goto yy1304;
	if (yych <= '9') goto yy1364;
	goto yy1304;
yy1326:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 'W') {
		if (yych <= 'M') {
			if (yych <= '/') goto yy1304;
			if (yych <= '9') goto yy1366;
			goto yy1304;
		} else {
			if (yych <= 'N') goto yy1368;
			if (yych == 'S') goto yy1368;
			goto yy1304;
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'X') goto yy1368;
			if (yych == 'n') goto yy1368;
			goto yy1304;
		} else {
			if (yych <= 's') goto yy1368;
			if (yych == 'x') goto yy1368;
			goto yy1304;
		}
	}
yy1327:
	yych = *++cur;
	if (yych <= '/') goto yy1304;
	if (yych <= '9') goto yy1369;
	goto yy1304;
yy1328:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1321;
	}
	goto yy1304;
yy1329:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= 'D') goto yy1323;
	if (yych <= 'F') goto yy1358;
	if (yych <= 'd') goto yy1323;
	if (yych <= 'f') goto yy1358;
	goto yy1323;
yy1330:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 'Q') {
		if (yych <= '9') {
			if (yych <= '/') goto yy1304;
			goto yy1371;
		} else {
			if (yych == 'L') goto yy1373;
			goto yy1304;
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'R') goto yy1373;
			if (yych <= 'k') goto yy1304;
			goto yy1373;
		} else {
			if (yych == 'r') goto yy1373;
			goto yy1304;
		}
	}
yy1331:
	yych = *++cur;
yy1332:
	if (yybm[0+yych] & 16) {
		goto yy1331;
	}
	if (yych >= 0x01) goto yy1334;
yy1333:
	cur = mar;
	if (yyaccept <= 2) {
		if (yyaccept <= 1) {
			if (yyaccept == 0) {
				goto yy1304;
			} else {
				goto yy1323;
			}
		} else {
			goto yy1335;
		}
	} else {
		if (yyaccept == 3) {
			goto yy1340;
		} else {
			goto yy1346;
		}
	}
yy1334:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy1331;
yy1335:
#line 614 "tokenizer.re"
	{ continue; }
#line 8351 "tokenizer.cpp"
yy1336:
	yych = *++cur;
yy1337:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1333;
			goto yy1336;
		} else {
			if (yych <= '\n') goto yy1338;
			if (yych <= '\v') goto yy1336;
			goto yy1333;
		}
	} else {
		if (yych <= 0x1F) {
			if (yych <= '\r') goto yy1336;
			goto yy1333;
		} else {
			if (yych <= ' ') goto yy1336;
			if (yych <= '!') goto yy1341;
			goto yy1333;
		}
	}
yy1338:
	yyaccept = 3;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 32) {
		goto yy1338;
	}
	if (yych <= 0x1F) goto yy1340;
	if (yych <= '!') goto yy1341;
	if (yych == '&') goto yy1374;
yy1340:
#line 613 "tokenizer.re"
	{ continue; }
#line 8386 "tokenizer.cpp"
yy1341:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy1341;
	}
	if (yych <= 0x00) goto yy1333;
	goto yy1338;
yy1343:
	yych = *++cur;
yy1344:
	if (yybm[0+yych] & 128) {
		goto yy1343;
	}
	if (yych <= 0x00) goto yy1333;
	yyaccept = 4;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy1343;
yy1346:
#line 615 "tokenizer.re"
	{ continue; }
#line 8407 "tokenizer.cpp"
yy1347:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1333;
			goto yy1347;
		} else {
			if (yych == '\v') goto yy1347;
			goto yy1333;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1347;
			if (yych <= 0x1F) goto yy1333;
			goto yy1347;
		} else {
			if (yych != '(') goto yy1333;
		}
	}
yy1349:
	++cur;
#line 595 "tokenizer.re"
	{
                cur--;
                unsigned char *tmp;
                lex_format(cur, loc, tmp);
                continue;
            }
#line 8436 "tokenizer.cpp"
yy1351:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1333;
			goto yy1351;
		} else {
			if (yych == '\v') goto yy1351;
			goto yy1333;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1351;
			if (yych <= 0x1F) goto yy1333;
			goto yy1351;
		} else {
			if (yych != '(') goto yy1333;
		}
	}
yy1353:
	++cur;
#line 589 "tokenizer.re"
	{
                cur--;
                unsigned char *tmp;
                lex_format(cur, loc, tmp);
                continue;
            }
#line 8465 "tokenizer.cpp"
yy1355:
	yych = *++cur;
yy1356:
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':	goto yy1351;
	case '(':	goto yy1353;
	case '/':
	case 'X':
	case 'x':	goto yy1318;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1355;
	case 'A':
	case 'a':	goto yy1321;
	case 'B':
	case 'I':
	case 'O':
	case 'Z':
	case 'b':
	case 'i':
	case 'o':
	case 'z':	goto yy1357;
	case 'D':
	case 'F':
	case 'd':
	case 'f':	goto yy1358;
	case 'E':
	case 'e':	goto yy1359;
	case 'G':
	case 'g':	goto yy1360;
	case 'L':
	case 'l':	goto yy1361;
	case 'P':
	case 'p':	goto yy1329;
	default:	goto yy1333;
	}
yy1357:
	yych = *++cur;
	if (yych <= '/') goto yy1333;
	if (yych <= '9') goto yy1362;
	goto yy1333;
yy1358:
	yych = *++cur;
	if (yych <= '/') goto yy1333;
	if (yych <= '9') goto yy1364;
	goto yy1333;
yy1359:
	yych = *++cur;
	if (yych <= 'W') {
		if (yych <= 'M') {
			if (yych <= '/') goto yy1333;
			if (yych <= '9') goto yy1366;
			goto yy1333;
		} else {
			if (yych <= 'N') goto yy1368;
			if (yych == 'S') goto yy1368;
			goto yy1333;
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'X') goto yy1368;
			if (yych == 'n') goto yy1368;
			goto yy1333;
		} else {
			if (yych <= 's') goto yy1368;
			if (yych == 'x') goto yy1368;
			goto yy1333;
		}
	}
yy1360:
	yych = *++cur;
	if (yych <= '/') goto yy1333;
	if (yych <= '9') goto yy1369;
	goto yy1333;
yy1361:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1321;
	}
	goto yy1333;
yy1362:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych == '.') goto yy1361;
	if (yych <= '/') goto yy1323;
	if (yych <= '9') goto yy1362;
	goto yy1323;
yy1364:
	yych = *++cur;
	if (yych == '.') goto yy1361;
	if (yych <= '/') goto yy1333;
	if (yych <= '9') goto yy1364;
	goto yy1333;
yy1366:
	yych = *++cur;
	if (yych == '.') goto yy1375;
	if (yych <= '/') goto yy1333;
	if (yych <= '9') goto yy1366;
	goto yy1333;
yy1368:
	yych = *++cur;
	if (yych <= '/') goto yy1333;
	if (yych <= '9') goto yy1366;
	goto yy1333;
yy1369:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych == '.') goto yy1375;
	if (yych <= '/') goto yy1323;
	if (yych <= '9') goto yy1369;
	goto yy1323;
yy1371:
	yych = *++cur;
	if (yych <= '/') goto yy1319;
	if (yych <= '9') goto yy1371;
	goto yy1319;
yy1373:
	yych = *++cur;
	if (yych <= '/') goto yy1333;
	if (yych <= '9') goto yy1371;
	goto yy1333;
yy1374:
	++cur;
	goto yy1340;
yy1375:
	yych = *++cur;
	if (yych <= '/') goto yy1333;
	if (yych >= ':') goto yy1333;
yy1376:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= 'D') {
		if (yych <= '/') goto yy1323;
		if (yych <= '9') goto yy1376;
		goto yy1323;
	} else {
		if (yych <= 'E') goto yy1361;
		if (yych == 'e') goto yy1361;
		goto yy1323;
	}
}
#line 618 "tokenizer.re"

    }
}

} // namespace LFortran
